/* f-application.c generated by valac 0.26.1, the Vala compiler
 * generated from f-application.vala, do not modify */

/*
 * Copyright 2011-2013 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <signal.h>


#define DIORITE_TYPE_APPLICATION (diorite_application_get_type ())
#define DIORITE_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_APPLICATION, DioriteApplication))
#define DIORITE_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_APPLICATION, DioriteApplicationClass))
#define DIORITE_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_APPLICATION))
#define DIORITE_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_APPLICATION))
#define DIORITE_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_APPLICATION, DioriteApplicationClass))

typedef struct _DioriteApplication DioriteApplication;
typedef struct _DioriteApplicationClass DioriteApplicationClass;
typedef struct _DioriteApplicationPrivate DioriteApplicationPrivate;

#define TYPE_XFCE_SESSION_MANAGER (xfce_session_manager_get_type ())
#define XFCE_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_XFCE_SESSION_MANAGER, XfceSessionManager))
#define IS_XFCE_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_XFCE_SESSION_MANAGER))
#define XFCE_SESSION_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_XFCE_SESSION_MANAGER, XfceSessionManagerIface))

typedef struct _XfceSessionManager XfceSessionManager;
typedef struct _XfceSessionManagerIface XfceSessionManagerIface;

#define TYPE_XFCE_SESSION_MANAGER_PROXY (xfce_session_manager_proxy_get_type ())

#define TYPE_GNOME_SESSION_MANAGER (gnome_session_manager_get_type ())
#define GNOME_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GNOME_SESSION_MANAGER, GnomeSessionManager))
#define IS_GNOME_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GNOME_SESSION_MANAGER))
#define GNOME_SESSION_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_GNOME_SESSION_MANAGER, GnomeSessionManagerIface))

typedef struct _GnomeSessionManager GnomeSessionManager;
typedef struct _GnomeSessionManagerIface GnomeSessionManagerIface;

#define TYPE_GNOME_SESSION_MANAGER_PROXY (gnome_session_manager_proxy_get_type ())

#define TYPE_GNOME_SESSION_CLIENT_PRIVATE (gnome_session_client_private_get_type ())
#define GNOME_SESSION_CLIENT_PRIVATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GNOME_SESSION_CLIENT_PRIVATE, GnomeSessionClientPrivate))
#define IS_GNOME_SESSION_CLIENT_PRIVATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GNOME_SESSION_CLIENT_PRIVATE))
#define GNOME_SESSION_CLIENT_PRIVATE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_GNOME_SESSION_CLIENT_PRIVATE, GnomeSessionClientPrivateIface))

typedef struct _GnomeSessionClientPrivate GnomeSessionClientPrivate;
typedef struct _GnomeSessionClientPrivateIface GnomeSessionClientPrivateIface;

#define TYPE_GNOME_SESSION_CLIENT_PRIVATE_PROXY (gnome_session_client_private_proxy_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef GDBusProxy XfceSessionManagerProxy;
typedef GDBusProxyClass XfceSessionManagerProxyClass;
typedef GDBusProxy GnomeSessionManagerProxy;
typedef GDBusProxyClass GnomeSessionManagerProxyClass;
typedef GDBusProxy GnomeSessionClientPrivateProxy;
typedef GDBusProxyClass GnomeSessionClientPrivateProxyClass;

typedef enum  {
	DIORITE_APP_ERROR_NOT_RUNNING,
	DIORITE_APP_ERROR_ALREADY_RUNNING,
	DIORITE_APP_ERROR_UNABLE_TO_TERMINATE,
	DIORITE_APP_ERROR_UNABLE_TO_ACTIVATE
} DioriteAppError;
#define DIORITE_APP_ERROR diorite_app_error_quark ()
struct _DioriteApplication {
	GtkApplication parent_instance;
	DioriteApplicationPrivate * priv;
};

struct _DioriteApplicationClass {
	GtkApplicationClass parent_class;
};

struct _XfceSessionManagerIface {
	GTypeInterface parent_iface;
};

struct _GnomeSessionManagerIface {
	GTypeInterface parent_iface;
	gchar* (*register_client) (GnomeSessionManager* self, const gchar* app_id, const gchar* startup_id, GError** error);
};

struct _GnomeSessionClientPrivateIface {
	GTypeInterface parent_iface;
	void (*end_session_response) (GnomeSessionClientPrivate* self, gboolean is_ok, const gchar* reason, GError** error);
};

struct _DioriteApplicationPrivate {
	gchar* _desktop_entry;
	gchar* _app_name;
	gchar* _path_name;
	gchar* _display_name;
	gchar* _icon;
	gchar* _version;
	XfceSessionManager* xfce_session;
	GnomeSessionManager* gnome_session;
	GnomeSessionClientPrivate* gnome_session_client;
};


static gpointer diorite_application_parent_class = NULL;
static DioriteApplication* diorite_application_instance;
static DioriteApplication* diorite_application_instance = NULL;

GQuark diorite_app_error_quark (void);
#define DIORITE_XFCE_SESSION_END 4
#define DIORITE_XFCE_SESSION_SERVICE_NAME "org.xfce.SessionManager"
#define DIORITE_XFCE_SESSION_SERVICE_OBJECT "/org/xfce/SessionManager"
#define DIORITE_GNOME_SESSION_SERVICE_NAME "org.gnome.SessionManager"
#define DIORITE_GNOME_SESSION_SERVICE_OBJECT "/org/gnome/SessionManager"
GType diorite_application_get_type (void) G_GNUC_CONST;
GType xfce_session_manager_get_type (void) G_GNUC_CONST;
GType xfce_session_manager_proxy_get_type (void) G_GNUC_CONST;
guint xfce_session_manager_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType gnome_session_manager_proxy_get_type (void) G_GNUC_CONST;
guint gnome_session_manager_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType gnome_session_manager_get_type (void) G_GNUC_CONST;
GType gnome_session_client_private_proxy_get_type (void) G_GNUC_CONST;
guint gnome_session_client_private_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType gnome_session_client_private_get_type (void) G_GNUC_CONST;
#define DIORITE_APPLICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_APPLICATION, DioriteApplicationPrivate))
enum  {
	DIORITE_APPLICATION_DUMMY_PROPERTY,
	DIORITE_APPLICATION_DESKTOP_ENTRY,
	DIORITE_APPLICATION_APP_NAME,
	DIORITE_APPLICATION_PATH_NAME,
	DIORITE_APPLICATION_DISPLAY_NAME,
	DIORITE_APPLICATION_ICON,
	DIORITE_APPLICATION_VERSION
};
DioriteApplication* diorite_application_construct (GType object_type, const gchar* name, const gchar* desktop_entry, const gchar* path_name, const gchar* startup_id);
void diorite_application_set_display_name (DioriteApplication* self, const gchar* value);
void diorite_application_set_app_name (DioriteApplication* self, const gchar* value);
void diorite_application_set_desktop_entry (DioriteApplication* self, const gchar* value);
void diorite_application_set_path_name (DioriteApplication* self, const gchar* value);
static void diorite_application_real_startup (GApplication* base);
gint prctl (gint option, const gchar* arg2, gulong arg3, gulong arg4, gulong arg5);
const gchar* diorite_application_get_app_name (DioriteApplication* self);
static void diorite_application_terminate_handler (gint sig_num);
static void _diorite_application_terminate_handler_sighandler_t (gint signal);
static void diorite_application_xfce_session_appeared (DioriteApplication* self, GDBusConnection* conn, const gchar* name, const gchar* owner);
static void _diorite_application_xfce_session_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self);
static void diorite_application_xfce_session_vanished (DioriteApplication* self, GDBusConnection* conn, const gchar* name);
static void _diorite_application_xfce_session_vanished_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void diorite_application_gnome_session_appeared (DioriteApplication* self, GDBusConnection* conn, const gchar* name, const gchar* owner);
static void _diorite_application_gnome_session_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self);
static void diorite_application_gnome_session_vanished (DioriteApplication* self, GDBusConnection* conn, const gchar* name);
static void _diorite_application_gnome_session_vanished_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self);
void diorite_application_quit (DioriteApplication* self);
void diorite_logger_lib_critical (const gchar* format, ...);
void diorite_logger_lib_debug (const gchar* format, ...);
void diorite_logger_lib_error (const gchar* format, ...);
static void diorite_application_xfce_session_state_changed (DioriteApplication* self, guint32 old_value, guint32 new_value);
static void _diorite_application_xfce_session_state_changed_xfce_session_manager_state_changed (XfceSessionManager* _sender, guint32 old_value, guint32 new_value, gpointer self);
void diorite_logger_lib_warning (const gchar* format, ...);
gchar* gnome_session_manager_register_client (GnomeSessionManager* self, const gchar* app_id, const gchar* startup_id, GError** error);
static void diorite_application_gnome_session_client_stop (DioriteApplication* self);
static void _diorite_application_gnome_session_client_stop_gnome_session_client_private_stop (GnomeSessionClientPrivate* _sender, gpointer self);
static void diorite_application_gnome_session_client_end (DioriteApplication* self, guint flags);
static void _diorite_application_gnome_session_client_end_gnome_session_client_private_end_session (GnomeSessionClientPrivate* _sender, guint flags, gpointer self);
static void diorite_application_gnome_session_client_query (DioriteApplication* self, guint flags);
static void _diorite_application_gnome_session_client_query_gnome_session_client_private_query_end_session (GnomeSessionClientPrivate* _sender, guint flags, gpointer self);
static void _diorite_application_gnome_session_client_end_gnome_session_client_private_query_end_session (GnomeSessionClientPrivate* _sender, guint flags, gpointer self);
void gnome_session_client_private_end_session_response (GnomeSessionClientPrivate* self, gboolean is_ok, const gchar* reason, GError** error);
const gchar* diorite_application_get_desktop_entry (DioriteApplication* self);
const gchar* diorite_application_get_path_name (DioriteApplication* self);
const gchar* diorite_application_get_display_name (DioriteApplication* self);
const gchar* diorite_application_get_icon (DioriteApplication* self);
void diorite_application_set_icon (DioriteApplication* self, const gchar* value);
const gchar* diorite_application_get_version (DioriteApplication* self);
void diorite_application_set_version (DioriteApplication* self, const gchar* value);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void diorite_application_finalize (GObject* obj);
static void _vala_diorite_application_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diorite_application_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void xfce_session_manager_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_xfce_session_manager_state_changed (XfceSessionManager* self, GVariant* parameters);
static void xfce_session_manager_proxy_xfce_session_manager_interface_init (XfceSessionManagerIface* iface);
static void xfce_session_manager_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* xfce_session_manager_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean xfce_session_manager_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_xfce_session_manager_state_changed (GObject* _sender, guint32 old_value, guint32 new_value, gpointer* _data);
static void _xfce_session_manager_unregister_object (gpointer user_data);
static void gnome_session_manager_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_gnome_session_manager_session_over (GnomeSessionManager* self, GVariant* parameters);
static gchar* gnome_session_manager_proxy_register_client (GnomeSessionManager* self, const gchar* app_id, const gchar* startup_id, GError** error);
static void gnome_session_manager_proxy_gnome_session_manager_interface_init (GnomeSessionManagerIface* iface);
static void _dbus_gnome_session_manager_register_client (GnomeSessionManager* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void gnome_session_manager_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* gnome_session_manager_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean gnome_session_manager_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_gnome_session_manager_session_over (GObject* _sender, gpointer* _data);
static void _gnome_session_manager_unregister_object (gpointer user_data);
static void gnome_session_client_private_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_gnome_session_client_private_stop (GnomeSessionClientPrivate* self, GVariant* parameters);
static void _dbus_handle_gnome_session_client_private_end_session (GnomeSessionClientPrivate* self, GVariant* parameters);
static void _dbus_handle_gnome_session_client_private_query_end_session (GnomeSessionClientPrivate* self, GVariant* parameters);
static void _dbus_handle_gnome_session_client_private_cancel_end_session (GnomeSessionClientPrivate* self, GVariant* parameters);
static void gnome_session_client_private_proxy_end_session_response (GnomeSessionClientPrivate* self, gboolean is_ok, const gchar* reason, GError** error);
static void gnome_session_client_private_proxy_gnome_session_client_private_interface_init (GnomeSessionClientPrivateIface* iface);
static void _dbus_gnome_session_client_private_end_session_response (GnomeSessionClientPrivate* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void gnome_session_client_private_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* gnome_session_client_private_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean gnome_session_client_private_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_gnome_session_client_private_stop (GObject* _sender, gpointer* _data);
static void _dbus_gnome_session_client_private_end_session (GObject* _sender, guint flags, gpointer* _data);
static void _dbus_gnome_session_client_private_query_end_session (GObject* _sender, guint flags, gpointer* _data);
static void _dbus_gnome_session_client_private_cancel_end_session (GObject* _sender, gpointer* _data);
static void _gnome_session_client_private_unregister_object (gpointer user_data);

static const GDBusMethodInfo * const _xfce_session_manager_dbus_method_info[] = {NULL};
static const GDBusArgInfo _xfce_session_manager_dbus_arg_info_state_changed_old_value = {-1, "old_value", "u"};
static const GDBusArgInfo _xfce_session_manager_dbus_arg_info_state_changed_new_value = {-1, "new_value", "u"};
static const GDBusArgInfo * const _xfce_session_manager_dbus_arg_info_state_changed[] = {&_xfce_session_manager_dbus_arg_info_state_changed_old_value, &_xfce_session_manager_dbus_arg_info_state_changed_new_value, NULL};
static const GDBusSignalInfo _xfce_session_manager_dbus_signal_info_state_changed = {-1, "StateChanged", (GDBusArgInfo **) (&_xfce_session_manager_dbus_arg_info_state_changed)};
static const GDBusSignalInfo * const _xfce_session_manager_dbus_signal_info[] = {&_xfce_session_manager_dbus_signal_info_state_changed, NULL};
static const GDBusPropertyInfo * const _xfce_session_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _xfce_session_manager_dbus_interface_info = {-1, "org.xfce.Session.Manager", (GDBusMethodInfo **) (&_xfce_session_manager_dbus_method_info), (GDBusSignalInfo **) (&_xfce_session_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_xfce_session_manager_dbus_property_info)};
static const GDBusInterfaceVTable _xfce_session_manager_dbus_interface_vtable = {xfce_session_manager_dbus_interface_method_call, xfce_session_manager_dbus_interface_get_property, xfce_session_manager_dbus_interface_set_property};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_register_client_app_id = {-1, "app_id", "s"};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_register_client_startup_id = {-1, "startup_id", "s"};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_register_client_result = {-1, "result", "s"};
static const GDBusArgInfo * const _gnome_session_manager_dbus_arg_info_register_client_in[] = {&_gnome_session_manager_dbus_arg_info_register_client_app_id, &_gnome_session_manager_dbus_arg_info_register_client_startup_id, NULL};
static const GDBusArgInfo * const _gnome_session_manager_dbus_arg_info_register_client_out[] = {&_gnome_session_manager_dbus_arg_info_register_client_result, NULL};
static const GDBusMethodInfo _gnome_session_manager_dbus_method_info_register_client = {-1, "RegisterClient", (GDBusArgInfo **) (&_gnome_session_manager_dbus_arg_info_register_client_in), (GDBusArgInfo **) (&_gnome_session_manager_dbus_arg_info_register_client_out)};
static const GDBusMethodInfo * const _gnome_session_manager_dbus_method_info[] = {&_gnome_session_manager_dbus_method_info_register_client, NULL};
static const GDBusArgInfo * const _gnome_session_manager_dbus_arg_info_session_over[] = {NULL};
static const GDBusSignalInfo _gnome_session_manager_dbus_signal_info_session_over = {-1, "SessionOver", (GDBusArgInfo **) (&_gnome_session_manager_dbus_arg_info_session_over)};
static const GDBusSignalInfo * const _gnome_session_manager_dbus_signal_info[] = {&_gnome_session_manager_dbus_signal_info_session_over, NULL};
static const GDBusPropertyInfo * const _gnome_session_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _gnome_session_manager_dbus_interface_info = {-1, "org.gnome.SessionManager", (GDBusMethodInfo **) (&_gnome_session_manager_dbus_method_info), (GDBusSignalInfo **) (&_gnome_session_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_gnome_session_manager_dbus_property_info)};
static const GDBusInterfaceVTable _gnome_session_manager_dbus_interface_vtable = {gnome_session_manager_dbus_interface_method_call, gnome_session_manager_dbus_interface_get_property, gnome_session_manager_dbus_interface_set_property};
static const GDBusArgInfo _gnome_session_client_private_dbus_arg_info_end_session_response_is_ok = {-1, "is_ok", "b"};
static const GDBusArgInfo _gnome_session_client_private_dbus_arg_info_end_session_response_reason = {-1, "reason", "s"};
static const GDBusArgInfo * const _gnome_session_client_private_dbus_arg_info_end_session_response_in[] = {&_gnome_session_client_private_dbus_arg_info_end_session_response_is_ok, &_gnome_session_client_private_dbus_arg_info_end_session_response_reason, NULL};
static const GDBusArgInfo * const _gnome_session_client_private_dbus_arg_info_end_session_response_out[] = {NULL};
static const GDBusMethodInfo _gnome_session_client_private_dbus_method_info_end_session_response = {-1, "EndSessionResponse", (GDBusArgInfo **) (&_gnome_session_client_private_dbus_arg_info_end_session_response_in), (GDBusArgInfo **) (&_gnome_session_client_private_dbus_arg_info_end_session_response_out)};
static const GDBusMethodInfo * const _gnome_session_client_private_dbus_method_info[] = {&_gnome_session_client_private_dbus_method_info_end_session_response, NULL};
static const GDBusArgInfo * const _gnome_session_client_private_dbus_arg_info_stop[] = {NULL};
static const GDBusSignalInfo _gnome_session_client_private_dbus_signal_info_stop = {-1, "Stop", (GDBusArgInfo **) (&_gnome_session_client_private_dbus_arg_info_stop)};
static const GDBusArgInfo _gnome_session_client_private_dbus_arg_info_end_session_flags = {-1, "flags", "u"};
static const GDBusArgInfo * const _gnome_session_client_private_dbus_arg_info_end_session[] = {&_gnome_session_client_private_dbus_arg_info_end_session_flags, NULL};
static const GDBusSignalInfo _gnome_session_client_private_dbus_signal_info_end_session = {-1, "EndSession", (GDBusArgInfo **) (&_gnome_session_client_private_dbus_arg_info_end_session)};
static const GDBusArgInfo _gnome_session_client_private_dbus_arg_info_query_end_session_flags = {-1, "flags", "u"};
static const GDBusArgInfo * const _gnome_session_client_private_dbus_arg_info_query_end_session[] = {&_gnome_session_client_private_dbus_arg_info_query_end_session_flags, NULL};
static const GDBusSignalInfo _gnome_session_client_private_dbus_signal_info_query_end_session = {-1, "QueryEndSession", (GDBusArgInfo **) (&_gnome_session_client_private_dbus_arg_info_query_end_session)};
static const GDBusArgInfo * const _gnome_session_client_private_dbus_arg_info_cancel_end_session[] = {NULL};
static const GDBusSignalInfo _gnome_session_client_private_dbus_signal_info_cancel_end_session = {-1, "CancelEndSession", (GDBusArgInfo **) (&_gnome_session_client_private_dbus_arg_info_cancel_end_session)};
static const GDBusSignalInfo * const _gnome_session_client_private_dbus_signal_info[] = {&_gnome_session_client_private_dbus_signal_info_stop, &_gnome_session_client_private_dbus_signal_info_end_session, &_gnome_session_client_private_dbus_signal_info_query_end_session, &_gnome_session_client_private_dbus_signal_info_cancel_end_session, NULL};
static const GDBusPropertyInfo * const _gnome_session_client_private_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _gnome_session_client_private_dbus_interface_info = {-1, "org.gnome.SessionManager.ClientPrivate", (GDBusMethodInfo **) (&_gnome_session_client_private_dbus_method_info), (GDBusSignalInfo **) (&_gnome_session_client_private_dbus_signal_info), (GDBusPropertyInfo **) (&_gnome_session_client_private_dbus_property_info)};
static const GDBusInterfaceVTable _gnome_session_client_private_dbus_interface_vtable = {gnome_session_client_private_dbus_interface_method_call, gnome_session_client_private_dbus_interface_get_property, gnome_session_client_private_dbus_interface_set_property};

GQuark diorite_app_error_quark (void) {
	return g_quark_from_static_string ("diorite_app_error-quark");
}


DioriteApplication* diorite_application_construct (GType object_type, const gchar* name, const gchar* desktop_entry, const gchar* path_name, const gchar* startup_id) {
	DioriteApplication * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (desktop_entry != NULL, NULL);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (path_name != NULL, NULL);
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = name;
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self = (DioriteApplication*) g_object_new (object_type, "application-id", _tmp0_, NULL);
#line 56 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = name;
#line 56 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_set_display_name (self, _tmp1_);
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp2_ = name;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_set_app_name (self, _tmp2_);
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp3_ = desktop_entry;
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_set_desktop_entry (self, _tmp3_);
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp4_ = path_name;
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_set_path_name (self, _tmp4_);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	return self;
#line 326 "f-application.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 71 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	return self ? g_object_ref (self) : NULL;
#line 333 "f-application.c"
}


static void _diorite_application_terminate_handler_sighandler_t (gint signal) {
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_terminate_handler (signal);
#line 340 "f-application.c"
}


static void _diorite_application_xfce_session_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self) {
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_xfce_session_appeared ((DioriteApplication*) self, connection, name, name_owner);
#line 347 "f-application.c"
}


static void _diorite_application_xfce_session_vanished_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_xfce_session_vanished ((DioriteApplication*) self, connection, name);
#line 354 "f-application.c"
}


static void _diorite_application_gnome_session_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self) {
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_gnome_session_appeared ((DioriteApplication*) self, connection, name, name_owner);
#line 361 "f-application.c"
}


static void _diorite_application_gnome_session_vanished_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_gnome_session_vanished ((DioriteApplication*) self, connection, name);
#line 368 "f-application.c"
}


static void diorite_application_real_startup (GApplication* base) {
	DioriteApplication * self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	DioriteApplication* _tmp3_ = NULL;
#line 64 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self = (DioriteApplication*) base;
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_application_hold ((GApplication*) self);
#line 67 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = self->priv->_app_name;
#line 67 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	prctl (15, _tmp0_, (gulong) 0, (gulong) 0, (gulong) 0);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = self->priv->_app_name;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_set_application_name (_tmp1_);
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp2_ = self->priv->_app_name;
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	gdk_set_program_class (_tmp2_);
#line 71 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp3_ = _g_object_ref0 (self);
#line 71 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_object_unref0 (diorite_application_instance);
#line 71 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_instance = _tmp3_;
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	signal (SIGINT, _diorite_application_terminate_handler_sighandler_t);
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	signal (SIGTERM, _diorite_application_terminate_handler_sighandler_t);
#line 74 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	signal (SIGHUP, _diorite_application_terminate_handler_sighandler_t);
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, DIORITE_XFCE_SESSION_SERVICE_NAME, G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((_diorite_application_xfce_session_appeared_gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _diorite_application_xfce_session_appeared_gbus_name_appeared_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((_diorite_application_xfce_session_vanished_gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _diorite_application_xfce_session_vanished_gbus_name_vanished_callback, g_object_ref (self), g_object_unref)));
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, DIORITE_GNOME_SESSION_SERVICE_NAME, G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((_diorite_application_gnome_session_appeared_gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _diorite_application_gnome_session_appeared_gbus_name_appeared_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((_diorite_application_gnome_session_vanished_gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _diorite_application_gnome_session_vanished_gbus_name_vanished_callback, g_object_ref (self), g_object_unref)));
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	G_APPLICATION_CLASS (diorite_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_APPLICATION, GtkApplication));
#line 412 "f-application.c"
}


/**
 * Quits application
 * 
 * Notice: This method differs from method GLib.Application.quit() (proviced
 * by GIO since version 2.32). If you called method hold(), you must call
 * also method release. In C, make sure you call diorite_application_quit()
 * instead of g_application_quit().
 */
void diorite_application_quit (DioriteApplication* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = g_application_get_is_remote ((GApplication*) self);
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = _tmp0_;
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (!_tmp1_) {
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_application_release ((GApplication*) self);
#line 437 "f-application.c"
	} else {
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_logger_lib_critical ("Remote quit not supported", NULL);
#line 441 "f-application.c"
	}
}


static void diorite_application_terminate_handler (gint sig_num) {
	gint _tmp0_ = 0;
	DioriteApplication* _tmp1_ = NULL;
	DioriteApplication* _tmp2_ = NULL;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = sig_num;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_logger_lib_debug ("Caught signal %d, exiting ...", _tmp0_, NULL);
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = diorite_application_instance;
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (_tmp1_ == NULL) {
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_logger_lib_error ("No instance to terminate", NULL);
#line 460 "f-application.c"
	}
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp2_ = diorite_application_instance;
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_quit (_tmp2_);
#line 466 "f-application.c"
}


static void _diorite_application_xfce_session_state_changed_xfce_session_manager_state_changed (XfceSessionManager* _sender, guint32 old_value, guint32 new_value, gpointer self) {
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_xfce_session_state_changed ((DioriteApplication*) self, old_value, new_value);
#line 473 "f-application.c"
}


static void diorite_application_xfce_session_appeared (DioriteApplication* self, GDBusConnection* conn, const gchar* name, const gchar* owner) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (conn != NULL);
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (name != NULL);
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (owner != NULL);
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = name;
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = owner;
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_logger_lib_debug ("XFCE session appeared: %s, %s", _tmp0_, _tmp1_, NULL);
#line 495 "f-application.c"
	{
		XfceSessionManager* _tmp2_ = NULL;
		XfceSessionManager* _tmp3_ = NULL;
		XfceSessionManager* _tmp4_ = NULL;
		XfceSessionManager* _tmp5_ = NULL;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp3_ = g_initable_new (TYPE_XFCE_SESSION_MANAGER_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", DIORITE_XFCE_SESSION_SERVICE_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", DIORITE_XFCE_SESSION_SERVICE_OBJECT, "g-interface-name", "org.xfce.Session.Manager", "g-interface-info", g_type_get_qdata (TYPE_XFCE_SESSION_MANAGER, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp2_ = (XfceSessionManager*) _tmp3_;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 509 "f-application.c"
				goto __catch15_g_io_error;
			}
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_clear_error (&_inner_error_);
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			return;
#line 518 "f-application.c"
		}
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp4_ = _tmp2_;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp2_ = NULL;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_object_unref0 (self->priv->xfce_session);
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		self->priv->xfce_session = _tmp4_;
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp5_ = self->priv->xfce_session;
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_signal_connect_object (_tmp5_, "state-changed", (GCallback) _diorite_application_xfce_session_state_changed_xfce_session_manager_state_changed, self, 0);
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_object_unref0 (_tmp2_);
#line 534 "f-application.c"
	}
	goto __finally15;
	__catch15_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		e = _inner_error_;
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_inner_error_ = NULL;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp6_ = e;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp7_ = _tmp6_->message;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_logger_lib_warning ("Unable to get proxy for Xfce session: %s", _tmp7_, NULL);
#line 123 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_object_unref0 (self->priv->xfce_session);
#line 123 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		self->priv->xfce_session = NULL;
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_error_free0 (e);
#line 558 "f-application.c"
	}
	__finally15:
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_clear_error (&_inner_error_);
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		return;
#line 569 "f-application.c"
	}
}


/**
 * Removes proxy object
 */
static void diorite_application_xfce_session_vanished (DioriteApplication* self, GDBusConnection* conn, const gchar* name) {
	const gchar* _tmp0_ = NULL;
	XfceSessionManager* _tmp1_ = NULL;
	XfceSessionManager* _tmp2_ = NULL;
	guint _tmp3_ = 0U;
#line 130 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 130 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (conn != NULL);
#line 130 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (name != NULL);
#line 131 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = name;
#line 131 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_logger_lib_debug ("XFCE session vanished: %s", _tmp0_, NULL);
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = self->priv->xfce_session;
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (_tmp1_ == NULL) {
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		return;
#line 598 "f-application.c"
	}
#line 133 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp2_ = self->priv->xfce_session;
#line 133 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_signal_parse_name ("state-changed", TYPE_XFCE_SESSION_MANAGER, &_tmp3_, NULL, FALSE);
#line 133 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _diorite_application_xfce_session_state_changed_xfce_session_manager_state_changed, self);
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_object_unref0 (self->priv->xfce_session);
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->xfce_session = NULL;
#line 610 "f-application.c"
}


static void diorite_application_xfce_session_state_changed (DioriteApplication* self, guint32 old_value, guint32 new_value) {
	guint32 _tmp0_ = 0U;
#line 137 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = new_value;
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (_tmp0_ == ((guint32) DIORITE_XFCE_SESSION_END)) {
#line 139 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_logger_lib_debug ("XFCE session end", NULL);
#line 140 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_application_quit (self);
#line 626 "f-application.c"
	}
}


static void _diorite_application_gnome_session_client_stop_gnome_session_client_private_stop (GnomeSessionClientPrivate* _sender, gpointer self) {
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_gnome_session_client_stop ((DioriteApplication*) self);
#line 634 "f-application.c"
}


static void _diorite_application_gnome_session_client_end_gnome_session_client_private_end_session (GnomeSessionClientPrivate* _sender, guint flags, gpointer self) {
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_gnome_session_client_end ((DioriteApplication*) self, flags);
#line 641 "f-application.c"
}


static void _diorite_application_gnome_session_client_query_gnome_session_client_private_query_end_session (GnomeSessionClientPrivate* _sender, guint flags, gpointer self) {
#line 158 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_gnome_session_client_query ((DioriteApplication*) self, flags);
#line 648 "f-application.c"
}


static void diorite_application_gnome_session_appeared (DioriteApplication* self, GDBusConnection* conn, const gchar* name, const gchar* owner) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (conn != NULL);
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (name != NULL);
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (owner != NULL);
#line 145 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = name;
#line 145 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = owner;
#line 145 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_logger_lib_debug ("GNOME session appeared: %s, %s", _tmp0_, _tmp1_, NULL);
#line 670 "f-application.c"
	{
		GnomeSessionManager* _tmp2_ = NULL;
		GnomeSessionManager* _tmp3_ = NULL;
		GnomeSessionManager* _tmp4_ = NULL;
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp3_ = g_initable_new (TYPE_GNOME_SESSION_MANAGER_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", DIORITE_GNOME_SESSION_SERVICE_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", DIORITE_GNOME_SESSION_SERVICE_OBJECT, "g-interface-name", "org.gnome.SessionManager", "g-interface-info", g_type_get_qdata (TYPE_GNOME_SESSION_MANAGER, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp2_ = (GnomeSessionManager*) _tmp3_;
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 683 "f-application.c"
				goto __catch16_g_io_error;
			}
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_clear_error (&_inner_error_);
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			return;
#line 692 "f-application.c"
		}
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp4_ = _tmp2_;
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp2_ = NULL;
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_object_unref0 (self->priv->gnome_session);
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		self->priv->gnome_session = _tmp4_;
#line 702 "f-application.c"
		{
			gchar* client_object = NULL;
			GnomeSessionManager* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			GnomeSessionClientPrivate* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
			GnomeSessionClientPrivate* _tmp10_ = NULL;
			GnomeSessionClientPrivate* _tmp11_ = NULL;
			GnomeSessionClientPrivate* _tmp12_ = NULL;
			GnomeSessionClientPrivate* _tmp13_ = NULL;
			GnomeSessionClientPrivate* _tmp14_ = NULL;
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp5_ = self->priv->gnome_session;
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp6_ = self->priv->_app_name;
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp7_ = gnome_session_manager_register_client (_tmp5_, _tmp6_, "", &_inner_error_);
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			client_object = _tmp7_;
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				if (_inner_error_->domain == G_IO_ERROR) {
#line 727 "f-application.c"
					goto __catch17_g_io_error;
				}
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				_g_object_unref0 (_tmp2_);
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				g_clear_error (&_inner_error_);
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				return;
#line 738 "f-application.c"
			}
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp9_ = client_object;
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp10_ = g_initable_new (TYPE_GNOME_SESSION_CLIENT_PRIVATE_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", DIORITE_GNOME_SESSION_SERVICE_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", _tmp9_, "g-interface-name", "org.gnome.SessionManager.ClientPrivate", "g-interface-info", g_type_get_qdata (TYPE_GNOME_SESSION_CLIENT_PRIVATE, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp8_ = (GnomeSessionClientPrivate*) _tmp10_;
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				_g_free0 (client_object);
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				if (_inner_error_->domain == G_IO_ERROR) {
#line 752 "f-application.c"
					goto __catch17_g_io_error;
				}
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				_g_free0 (client_object);
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				_g_object_unref0 (_tmp2_);
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				g_clear_error (&_inner_error_);
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
				return;
#line 765 "f-application.c"
			}
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp11_ = _tmp8_;
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp8_ = NULL;
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_g_object_unref0 (self->priv->gnome_session_client);
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			self->priv->gnome_session_client = _tmp11_;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp12_ = self->priv->gnome_session_client;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_signal_connect_object (_tmp12_, "stop", (GCallback) _diorite_application_gnome_session_client_stop_gnome_session_client_private_stop, self, 0);
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp13_ = self->priv->gnome_session_client;
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_signal_connect_object (_tmp13_, "end-session", (GCallback) _diorite_application_gnome_session_client_end_gnome_session_client_private_end_session, self, 0);
#line 158 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp14_ = self->priv->gnome_session_client;
#line 158 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_signal_connect_object (_tmp14_, "query-end-session", (GCallback) _diorite_application_gnome_session_client_query_gnome_session_client_private_query_end_session, self, 0);
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_g_object_unref0 (_tmp8_);
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_g_free0 (client_object);
#line 791 "f-application.c"
		}
		goto __finally17;
		__catch17_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			e = _inner_error_;
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_inner_error_ = NULL;
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp15_ = e;
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_tmp16_ = _tmp15_->message;
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			diorite_logger_lib_warning ("Unable to get proxy for GNOME session client: %s", _tmp16_, NULL);
#line 162 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_g_object_unref0 (self->priv->gnome_session);
#line 162 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			self->priv->gnome_session = NULL;
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_g_error_free0 (e);
#line 815 "f-application.c"
		}
		__finally17:
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_g_object_unref0 (_tmp2_);
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 824 "f-application.c"
				goto __catch16_g_io_error;
			}
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			_g_object_unref0 (_tmp2_);
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_clear_error (&_inner_error_);
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			return;
#line 835 "f-application.c"
		}
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_object_unref0 (_tmp2_);
#line 839 "f-application.c"
	}
	goto __finally16;
	__catch16_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		e = _inner_error_;
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_inner_error_ = NULL;
#line 166 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp17_ = e;
#line 166 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp18_ = _tmp17_->message;
#line 166 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_logger_lib_warning ("Unable to get proxy for GNOME session: %s", _tmp18_, NULL);
#line 167 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_object_unref0 (self->priv->gnome_session);
#line 167 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		self->priv->gnome_session = NULL;
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_error_free0 (e);
#line 863 "f-application.c"
	}
	__finally16:
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_clear_error (&_inner_error_);
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		return;
#line 874 "f-application.c"
	}
}


/**
 * Removes proxy object
 */
static void _diorite_application_gnome_session_client_end_gnome_session_client_private_query_end_session (GnomeSessionClientPrivate* _sender, guint flags, gpointer self) {
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_gnome_session_client_end ((DioriteApplication*) self, flags);
#line 885 "f-application.c"
}


static void diorite_application_gnome_session_vanished (DioriteApplication* self, GDBusConnection* conn, const gchar* name) {
	const gchar* _tmp0_ = NULL;
	GnomeSessionManager* _tmp1_ = NULL;
	GnomeSessionClientPrivate* _tmp2_ = NULL;
	GnomeSessionClientPrivate* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
	GnomeSessionClientPrivate* _tmp5_ = NULL;
	guint _tmp6_ = 0U;
	GnomeSessionClientPrivate* _tmp7_ = NULL;
	guint _tmp8_ = 0U;
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (conn != NULL);
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (name != NULL);
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = name;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_logger_lib_debug ("GNOME session vanished: %s", _tmp0_, NULL);
#line 176 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = self->priv->gnome_session;
#line 176 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (_tmp1_ == NULL) {
#line 176 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		return;
#line 915 "f-application.c"
	}
#line 177 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_object_unref0 (self->priv->gnome_session);
#line 177 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->gnome_session = NULL;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp2_ = self->priv->gnome_session_client;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (_tmp2_ == NULL) {
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		return;
#line 927 "f-application.c"
	}
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp3_ = self->priv->gnome_session_client;
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_signal_parse_name ("stop", TYPE_GNOME_SESSION_CLIENT_PRIVATE, &_tmp4_, NULL, FALSE);
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _diorite_application_gnome_session_client_stop_gnome_session_client_private_stop, self);
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp5_ = self->priv->gnome_session_client;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_signal_parse_name ("end-session", TYPE_GNOME_SESSION_CLIENT_PRIVATE, &_tmp6_, NULL, FALSE);
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _diorite_application_gnome_session_client_end_gnome_session_client_private_end_session, self);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp7_ = self->priv->gnome_session_client;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_signal_parse_name ("query-end-session", TYPE_GNOME_SESSION_CLIENT_PRIVATE, &_tmp8_, NULL, FALSE);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _diorite_application_gnome_session_client_end_gnome_session_client_private_query_end_session, self);
#line 183 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_object_unref0 (self->priv->gnome_session_client);
#line 183 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->gnome_session_client = NULL;
#line 951 "f-application.c"
}


static void diorite_application_gnome_session_client_stop (DioriteApplication* self) {
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_logger_lib_debug ("GNOME Session client signal: %s", "stop", NULL);
#line 189 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_quit (self);
#line 962 "f-application.c"
}


static void diorite_application_gnome_session_client_query (DioriteApplication* self, guint flags) {
	guint _tmp0_ = 0U;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GnomeSessionClientPrivate* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 192 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = flags;
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = g_strdup_printf ("%u", _tmp0_);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp2_ = _tmp1_;
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp3_ = g_strconcat ("GNOME Session client signal: %s, ", _tmp2_, NULL);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp4_ = _tmp3_;
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_logger_lib_debug (_tmp4_, "query-end-session", NULL);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (_tmp4_);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (_tmp2_);
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp5_ = self->priv->gnome_session_client;
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (_tmp5_ == NULL) {
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		return;
#line 998 "f-application.c"
	}
	{
		GnomeSessionClientPrivate* _tmp6_ = NULL;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp6_ = self->priv->gnome_session_client;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		gnome_session_client_private_end_session_response (_tmp6_, TRUE, "", &_inner_error_);
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 1010 "f-application.c"
				goto __catch18_g_io_error;
			}
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_clear_error (&_inner_error_);
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			return;
#line 1019 "f-application.c"
		}
	}
	goto __finally18;
	__catch18_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		e = _inner_error_;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_inner_error_ = NULL;
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp7_ = e;
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp8_ = _tmp7_->message;
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_logger_lib_warning ("Unable to send end session response for GNOME session client: %s", _tmp8_, NULL);
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_error_free0 (e);
#line 1040 "f-application.c"
	}
	__finally18:
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_clear_error (&_inner_error_);
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		return;
#line 1051 "f-application.c"
	}
}


static void diorite_application_gnome_session_client_end (DioriteApplication* self, guint flags) {
	guint _tmp0_ = 0U;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GnomeSessionClientPrivate* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = flags;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = g_strdup_printf ("%u", _tmp0_);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp2_ = _tmp1_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp3_ = g_strconcat ("GNOME Session client signal: %s, ", _tmp2_, NULL);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp4_ = _tmp3_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_logger_lib_debug (_tmp4_, "end-session", NULL);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (_tmp4_);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (_tmp2_);
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp5_ = self->priv->gnome_session_client;
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (_tmp5_ == NULL) {
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		return;
#line 1088 "f-application.c"
	}
	{
		GnomeSessionClientPrivate* _tmp6_ = NULL;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp6_ = self->priv->gnome_session_client;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		gnome_session_client_private_end_session_response (_tmp6_, TRUE, "", &_inner_error_);
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 1100 "f-application.c"
				goto __catch19_g_io_error;
			}
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			g_clear_error (&_inner_error_);
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
			return;
#line 1109 "f-application.c"
		}
	}
	goto __finally19;
	__catch19_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		e = _inner_error_;
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_inner_error_ = NULL;
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp7_ = e;
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_tmp8_ = _tmp7_->message;
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_logger_lib_warning ("Unable to send end session response for GNOME session client: %s", _tmp8_, NULL);
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		_g_error_free0 (e);
#line 1130 "f-application.c"
	}
	__finally19:
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_clear_error (&_inner_error_);
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		return;
#line 1141 "f-application.c"
	}
}


const gchar* diorite_application_get_desktop_entry (DioriteApplication* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = self->priv->_desktop_entry;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	result = _tmp0_;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	return result;
#line 1157 "f-application.c"
}


void diorite_application_set_desktop_entry (DioriteApplication* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = value;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_desktop_entry);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->_desktop_entry = _tmp1_;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_notify ((GObject *) self, "desktop-entry");
#line 1176 "f-application.c"
}


const gchar* diorite_application_get_app_name (DioriteApplication* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = self->priv->_app_name;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	result = _tmp0_;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	return result;
#line 1191 "f-application.c"
}


void diorite_application_set_app_name (DioriteApplication* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = value;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_app_name);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->_app_name = _tmp1_;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_notify ((GObject *) self, "app-name");
#line 1210 "f-application.c"
}


const gchar* diorite_application_get_path_name (DioriteApplication* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = self->priv->_path_name;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	result = _tmp0_;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	return result;
#line 1225 "f-application.c"
}


void diorite_application_set_path_name (DioriteApplication* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = value;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_path_name);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->_path_name = _tmp1_;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_notify ((GObject *) self, "path-name");
#line 1244 "f-application.c"
}


const gchar* diorite_application_get_display_name (DioriteApplication* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = self->priv->_display_name;
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	result = _tmp0_;
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	return result;
#line 1259 "f-application.c"
}


void diorite_application_set_display_name (DioriteApplication* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = value;
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_display_name);
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->_display_name = _tmp1_;
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_notify ((GObject *) self, "display-name");
#line 1278 "f-application.c"
}


const gchar* diorite_application_get_icon (DioriteApplication* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = self->priv->_icon;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	result = _tmp0_;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	return result;
#line 1293 "f-application.c"
}


void diorite_application_set_icon (DioriteApplication* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = value;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_icon);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->_icon = _tmp1_;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_notify ((GObject *) self, "icon");
#line 1312 "f-application.c"
}


const gchar* diorite_application_get_version (DioriteApplication* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = self->priv->_version;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	result = _tmp0_;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	return result;
#line 1327 "f-application.c"
}


void diorite_application_set_version (DioriteApplication* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = value;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_version);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->_version = _tmp1_;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_notify ((GObject *) self, "version");
#line 1346 "f-application.c"
}


static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (n_param_values == 3);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		data1 = closure->data;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		data2 = param_values->data[0].v_pointer;
#line 1365 "f-application.c"
	} else {
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		data1 = param_values->data[0].v_pointer;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		data2 = closure->data;
#line 1371 "f-application.c"
	}
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 1377 "f-application.c"
}


static void diorite_application_class_init (DioriteApplicationClass * klass) {
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	diorite_application_parent_class = g_type_class_peek_parent (klass);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_type_class_add_private (klass, sizeof (DioriteApplicationPrivate));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	((GApplicationClass *) klass)->startup = diorite_application_real_startup;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_diorite_application_get_property;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_diorite_application_set_property;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	G_OBJECT_CLASS (klass)->finalize = diorite_application_finalize;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_APPLICATION_DESKTOP_ENTRY, g_param_spec_string ("desktop-entry", "desktop-entry", "desktop-entry", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_APPLICATION_APP_NAME, g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_APPLICATION_PATH_NAME, g_param_spec_string ("path-name", "path-name", "path-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_APPLICATION_DISPLAY_NAME, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_APPLICATION_ICON, g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_APPLICATION_VERSION, g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_signal_new ("show_user_info", DIORITE_TYPE_APPLICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
#line 1408 "f-application.c"
}


static void diorite_application_instance_init (DioriteApplication * self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv = DIORITE_APPLICATION_GET_PRIVATE (self);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp0_ = g_strdup ("");
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->_icon = _tmp0_;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_tmp1_ = g_strdup ("");
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->_version = _tmp1_;
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->xfce_session = NULL;
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->gnome_session = NULL;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self->priv->gnome_session_client = NULL;
#line 1431 "f-application.c"
}


static void diorite_application_finalize (GObject* obj) {
	DioriteApplication * self;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_APPLICATION, DioriteApplication);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_desktop_entry);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_app_name);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_path_name);
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_display_name);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_icon);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_free0 (self->priv->_version);
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_object_unref0 (self->priv->xfce_session);
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_object_unref0 (self->priv->gnome_session);
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	_g_object_unref0 (self->priv->gnome_session_client);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	G_OBJECT_CLASS (diorite_application_parent_class)->finalize (obj);
#line 1459 "f-application.c"
}


GType diorite_application_get_type (void) {
	static volatile gsize diorite_application_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_application_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteApplication), 0, (GInstanceInitFunc) diorite_application_instance_init, NULL };
		GType diorite_application_type_id;
		diorite_application_type_id = g_type_register_static (GTK_TYPE_APPLICATION, "DioriteApplication", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&diorite_application_type_id__volatile, diorite_application_type_id);
	}
	return diorite_application_type_id__volatile;
}


static void _vala_diorite_application_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioriteApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_APPLICATION, DioriteApplication);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	switch (property_id) {
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_DESKTOP_ENTRY:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_value_set_string (value, diorite_application_get_desktop_entry (self));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_APP_NAME:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_value_set_string (value, diorite_application_get_app_name (self));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_PATH_NAME:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_value_set_string (value, diorite_application_get_path_name (self));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_DISPLAY_NAME:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_value_set_string (value, diorite_application_get_display_name (self));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_ICON:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_value_set_string (value, diorite_application_get_icon (self));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_VERSION:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_value_set_string (value, diorite_application_get_version (self));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 1516 "f-application.c"
		default:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 1522 "f-application.c"
	}
}


static void _vala_diorite_application_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioriteApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_APPLICATION, DioriteApplication);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	switch (property_id) {
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_DESKTOP_ENTRY:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_application_set_desktop_entry (self, g_value_get_string (value));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_APP_NAME:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_application_set_app_name (self, g_value_get_string (value));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_PATH_NAME:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_application_set_path_name (self, g_value_get_string (value));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_DISPLAY_NAME:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_application_set_display_name (self, g_value_get_string (value));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_ICON:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_application_set_icon (self, g_value_get_string (value));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		case DIORITE_APPLICATION_VERSION:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		diorite_application_set_version (self, g_value_get_string (value));
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 1568 "f-application.c"
		default:
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		break;
#line 1574 "f-application.c"
	}
}


static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint32 arg_1, guint32 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (n_param_values == 3);
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		data1 = closure->data;
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		data2 = param_values->data[0].v_pointer;
#line 1594 "f-application.c"
	} else {
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		data1 = param_values->data[0].v_pointer;
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		data2 = closure->data;
#line 1600 "f-application.c"
	}
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 1606 "f-application.c"
}


static void xfce_session_manager_base_init (XfceSessionManagerIface * iface) {
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	static gboolean initialized = FALSE;
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (!initialized) {
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		initialized = TRUE;
#line 218 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_signal_new ("state_changed", TYPE_XFCE_SESSION_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
#line 1619 "f-application.c"
	}
}


GType xfce_session_manager_get_type (void) {
	static volatile gsize xfce_session_manager_type_id__volatile = 0;
	if (g_once_init_enter (&xfce_session_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (XfceSessionManagerIface), (GBaseInitFunc) xfce_session_manager_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType xfce_session_manager_type_id;
		xfce_session_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "XfceSessionManager", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (xfce_session_manager_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (xfce_session_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) xfce_session_manager_proxy_get_type);
		g_type_set_qdata (xfce_session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.xfce.Session.Manager");
		g_type_set_qdata (xfce_session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_xfce_session_manager_dbus_interface_info));
		g_type_set_qdata (xfce_session_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) xfce_session_manager_register_object);
		g_once_init_leave (&xfce_session_manager_type_id__volatile, xfce_session_manager_type_id);
	}
	return xfce_session_manager_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (XfceSessionManagerProxy, xfce_session_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_XFCE_SESSION_MANAGER, xfce_session_manager_proxy_xfce_session_manager_interface_init) )
static void xfce_session_manager_proxy_class_init (XfceSessionManagerProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = xfce_session_manager_proxy_g_signal;
}


static void _dbus_handle_xfce_session_manager_state_changed (XfceSessionManager* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	guint32 old_value = 0U;
	GVariant* _tmp0_;
	guint32 new_value = 0U;
	GVariant* _tmp1_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	old_value = g_variant_get_uint32 (_tmp0_);
	g_variant_unref (_tmp0_);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	new_value = g_variant_get_uint32 (_tmp1_);
	g_variant_unref (_tmp1_);
	g_signal_emit_by_name (self, "state-changed", old_value, new_value);
}


static void xfce_session_manager_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "StateChanged") == 0) {
		_dbus_handle_xfce_session_manager_state_changed ((XfceSessionManager*) proxy, parameters);
	}
}


static void xfce_session_manager_proxy_init (XfceSessionManagerProxy* self) {
}


static void xfce_session_manager_proxy_xfce_session_manager_interface_init (XfceSessionManagerIface* iface) {
}


static void xfce_session_manager_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}


static GVariant* xfce_session_manager_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean xfce_session_manager_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_xfce_session_manager_state_changed (GObject* _sender, guint32 old_value, guint32 new_value, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (old_value));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (new_value));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.xfce.Session.Manager", "StateChanged", _arguments, NULL);
}


guint xfce_session_manager_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_xfce_session_manager_dbus_interface_info), &_xfce_session_manager_dbus_interface_vtable, data, _xfce_session_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "state-changed", (GCallback) _dbus_xfce_session_manager_state_changed, data);
	return result;
}


static void _xfce_session_manager_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_xfce_session_manager_state_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


gchar* gnome_session_manager_register_client (GnomeSessionManager* self, const gchar* app_id, const gchar* startup_id, GError** error) {
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	return GNOME_SESSION_MANAGER_GET_INTERFACE (self)->register_client (self, app_id, startup_id, error);
#line 1753 "f-application.c"
}


static void gnome_session_manager_base_init (GnomeSessionManagerIface * iface) {
#line 224 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	static gboolean initialized = FALSE;
#line 224 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (!initialized) {
#line 224 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		initialized = TRUE;
#line 224 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_signal_new ("session_over", TYPE_GNOME_SESSION_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1766 "f-application.c"
	}
}


GType gnome_session_manager_get_type (void) {
	static volatile gsize gnome_session_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gnome_session_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomeSessionManagerIface), (GBaseInitFunc) gnome_session_manager_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gnome_session_manager_type_id;
		gnome_session_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "GnomeSessionManager", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gnome_session_manager_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (gnome_session_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) gnome_session_manager_proxy_get_type);
		g_type_set_qdata (gnome_session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SessionManager");
		g_type_set_qdata (gnome_session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_gnome_session_manager_dbus_interface_info));
		g_type_set_qdata (gnome_session_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) gnome_session_manager_register_object);
		g_once_init_leave (&gnome_session_manager_type_id__volatile, gnome_session_manager_type_id);
	}
	return gnome_session_manager_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (GnomeSessionManagerProxy, gnome_session_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_GNOME_SESSION_MANAGER, gnome_session_manager_proxy_gnome_session_manager_interface_init) )
static void gnome_session_manager_proxy_class_init (GnomeSessionManagerProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = gnome_session_manager_proxy_g_signal;
}


static void _dbus_handle_gnome_session_manager_session_over (GnomeSessionManager* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "session-over");
}


static void gnome_session_manager_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "SessionOver") == 0) {
		_dbus_handle_gnome_session_manager_session_over ((GnomeSessionManager*) proxy, parameters);
	}
}


static void gnome_session_manager_proxy_init (GnomeSessionManagerProxy* self) {
}


static gchar* gnome_session_manager_proxy_register_client (GnomeSessionManager* self, const gchar* app_id, const gchar* startup_id, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp2_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager", "RegisterClient");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (startup_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp2_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	g_object_unref (_reply_message);
	return _result;
}


static void gnome_session_manager_proxy_gnome_session_manager_interface_init (GnomeSessionManagerIface* iface) {
	iface->register_client = gnome_session_manager_proxy_register_client;
}


static void _dbus_gnome_session_manager_register_client (GnomeSessionManager* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* app_id = NULL;
	GVariant* _tmp3_;
	gchar* startup_id = NULL;
	GVariant* _tmp4_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	app_id = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	startup_id = g_variant_dup_string (_tmp4_, NULL);
	g_variant_unref (_tmp4_);
	result = gnome_session_manager_register_client (self, app_id, startup_id, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (app_id);
	_g_free0 (startup_id);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void gnome_session_manager_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "RegisterClient") == 0) {
		_dbus_gnome_session_manager_register_client (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* gnome_session_manager_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean gnome_session_manager_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_gnome_session_manager_session_over (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.SessionManager", "SessionOver", _arguments, NULL);
}


guint gnome_session_manager_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_gnome_session_manager_dbus_interface_info), &_gnome_session_manager_dbus_interface_vtable, data, _gnome_session_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "session-over", (GCallback) _dbus_gnome_session_manager_session_over, data);
	return result;
}


static void _gnome_session_manager_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gnome_session_manager_session_over, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


void gnome_session_client_private_end_session_response (GnomeSessionClientPrivate* self, gboolean is_ok, const gchar* reason, GError** error) {
#line 237 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	g_return_if_fail (self != NULL);
#line 237 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	GNOME_SESSION_CLIENT_PRIVATE_GET_INTERFACE (self)->end_session_response (self, is_ok, reason, error);
#line 1965 "f-application.c"
}


static void gnome_session_client_private_base_init (GnomeSessionClientPrivateIface * iface) {
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	static gboolean initialized = FALSE;
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
	if (!initialized) {
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		initialized = TRUE;
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_signal_new ("stop", TYPE_GNOME_SESSION_CLIENT_PRIVATE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_signal_new ("end_session", TYPE_GNOME_SESSION_CLIENT_PRIVATE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_signal_new ("query_end_session", TYPE_GNOME_SESSION_CLIENT_PRIVATE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/f-application.vala"
		g_signal_new ("cancel_end_session", TYPE_GNOME_SESSION_CLIENT_PRIVATE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1984 "f-application.c"
	}
}


GType gnome_session_client_private_get_type (void) {
	static volatile gsize gnome_session_client_private_type_id__volatile = 0;
	if (g_once_init_enter (&gnome_session_client_private_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomeSessionClientPrivateIface), (GBaseInitFunc) gnome_session_client_private_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gnome_session_client_private_type_id;
		gnome_session_client_private_type_id = g_type_register_static (G_TYPE_INTERFACE, "GnomeSessionClientPrivate", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gnome_session_client_private_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (gnome_session_client_private_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) gnome_session_client_private_proxy_get_type);
		g_type_set_qdata (gnome_session_client_private_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SessionManager.ClientPrivate");
		g_type_set_qdata (gnome_session_client_private_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_gnome_session_client_private_dbus_interface_info));
		g_type_set_qdata (gnome_session_client_private_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) gnome_session_client_private_register_object);
		g_once_init_leave (&gnome_session_client_private_type_id__volatile, gnome_session_client_private_type_id);
	}
	return gnome_session_client_private_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (GnomeSessionClientPrivateProxy, gnome_session_client_private_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_GNOME_SESSION_CLIENT_PRIVATE, gnome_session_client_private_proxy_gnome_session_client_private_interface_init) )
static void gnome_session_client_private_proxy_class_init (GnomeSessionClientPrivateProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = gnome_session_client_private_proxy_g_signal;
}


static void _dbus_handle_gnome_session_client_private_stop (GnomeSessionClientPrivate* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "stop");
}


static void _dbus_handle_gnome_session_client_private_end_session (GnomeSessionClientPrivate* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	guint flags = 0U;
	GVariant* _tmp5_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp5_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint32 (_tmp5_);
	g_variant_unref (_tmp5_);
	g_signal_emit_by_name (self, "end-session", flags);
}


static void _dbus_handle_gnome_session_client_private_query_end_session (GnomeSessionClientPrivate* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	guint flags = 0U;
	GVariant* _tmp6_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp6_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint32 (_tmp6_);
	g_variant_unref (_tmp6_);
	g_signal_emit_by_name (self, "query-end-session", flags);
}


static void _dbus_handle_gnome_session_client_private_cancel_end_session (GnomeSessionClientPrivate* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "cancel-end-session");
}


static void gnome_session_client_private_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "Stop") == 0) {
		_dbus_handle_gnome_session_client_private_stop ((GnomeSessionClientPrivate*) proxy, parameters);
	} else if (strcmp (signal_name, "EndSession") == 0) {
		_dbus_handle_gnome_session_client_private_end_session ((GnomeSessionClientPrivate*) proxy, parameters);
	} else if (strcmp (signal_name, "QueryEndSession") == 0) {
		_dbus_handle_gnome_session_client_private_query_end_session ((GnomeSessionClientPrivate*) proxy, parameters);
	} else if (strcmp (signal_name, "CancelEndSession") == 0) {
		_dbus_handle_gnome_session_client_private_cancel_end_session ((GnomeSessionClientPrivate*) proxy, parameters);
	}
}


static void gnome_session_client_private_proxy_init (GnomeSessionClientPrivateProxy* self) {
}


static void gnome_session_client_private_proxy_end_session_response (GnomeSessionClientPrivate* self, gboolean is_ok, const gchar* reason, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager.ClientPrivate", "EndSessionResponse");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (is_ok));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (reason));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void gnome_session_client_private_proxy_gnome_session_client_private_interface_init (GnomeSessionClientPrivateIface* iface) {
	iface->end_session_response = gnome_session_client_private_proxy_end_session_response;
}


static void _dbus_gnome_session_client_private_end_session_response (GnomeSessionClientPrivate* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean is_ok = FALSE;
	GVariant* _tmp7_;
	gchar* reason = NULL;
	GVariant* _tmp8_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	is_ok = g_variant_get_boolean (_tmp7_);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	reason = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	gnome_session_client_private_end_session_response (self, is_ok, reason, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (reason);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void gnome_session_client_private_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "EndSessionResponse") == 0) {
		_dbus_gnome_session_client_private_end_session_response (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* gnome_session_client_private_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean gnome_session_client_private_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_gnome_session_client_private_stop (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.SessionManager.ClientPrivate", "Stop", _arguments, NULL);
}


static void _dbus_gnome_session_client_private_end_session (GObject* _sender, guint flags, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (flags));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.SessionManager.ClientPrivate", "EndSession", _arguments, NULL);
}


static void _dbus_gnome_session_client_private_query_end_session (GObject* _sender, guint flags, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (flags));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.SessionManager.ClientPrivate", "QueryEndSession", _arguments, NULL);
}


static void _dbus_gnome_session_client_private_cancel_end_session (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.SessionManager.ClientPrivate", "CancelEndSession", _arguments, NULL);
}


guint gnome_session_client_private_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_gnome_session_client_private_dbus_interface_info), &_gnome_session_client_private_dbus_interface_vtable, data, _gnome_session_client_private_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "stop", (GCallback) _dbus_gnome_session_client_private_stop, data);
	g_signal_connect (object, "end-session", (GCallback) _dbus_gnome_session_client_private_end_session, data);
	g_signal_connect (object, "query-end-session", (GCallback) _dbus_gnome_session_client_private_query_end_session, data);
	g_signal_connect (object, "cancel-end-session", (GCallback) _dbus_gnome_session_client_private_cancel_end_session, data);
	return result;
}


static void _gnome_session_client_private_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gnome_session_client_private_stop, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gnome_session_client_private_end_session, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gnome_session_client_private_query_end_session, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gnome_session_client_private_cancel_end_session, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}



