/* system.c generated by valac 0.26.1, the Vala compiler
 * generated from system.vala, do not modify */

/*
 * Copyright 2011-2012 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))



void diorite_system_open_uri (const gchar* uri, GError** error);
void diorite_logger_lib_debug (const gchar* format, ...);
void diorite_system_open_uri_with_fallback (const gchar* uri);
void diorite_logger_lib_warning (const gchar* format, ...);
gchar* diorite_system_read_file (GFile* file, GError** error);
void diorite_system_overwrite_file (GFile* file, const gchar* contents, GError** error);
void diorite_system_purge_directory_content (GFile* dir, gboolean recursive, GError** error);
gboolean diorite_system_try_purge_dir (GFile* dir, gboolean recursive);
gint prctl (gint option, const gchar* arg2, gulong arg3, gulong arg4, gulong arg5);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
 * Opens URI in the default application
 * 
 * @param uri URI to open
 */
void diorite_system_open_uri (const gchar* uri, GError** error) {
	gchar** args = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint args_length1 = 0;
	gint _args_size_ = 0;
	const gchar* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_return_if_fail (uri != NULL);
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp0_ = g_strdup ("xdg-open");
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp1_ = uri;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp3_ = g_new0 (gchar*, 2 + 1);
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp3_[0] = _tmp0_;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp3_[1] = _tmp2_;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	args = _tmp3_;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	args_length1 = 2;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_args_size_ = args_length1;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp4_ = uri;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	diorite_logger_lib_debug ("xdg-open %s", _tmp4_, NULL);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_spawn_async (NULL, args, NULL, G_SPAWN_LEAVE_DESCRIPTORS_OPEN | G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, &_inner_error_);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		if (_inner_error_->domain == G_SPAWN_ERROR) {
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			g_propagate_error (error, _inner_error_);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			return;
#line 105 "system.c"
		} else {
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			g_clear_error (&_inner_error_);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			return;
#line 115 "system.c"
		}
	}
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 120 "system.c"
}


/**
 * Opens URI in the default application
 * 
 * @param uri URI to open
 */
void diorite_system_open_uri_with_fallback (const gchar* uri) {
	GError * _inner_error_ = NULL;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_return_if_fail (uri != NULL);
#line 133 "system.c"
	{
		const gchar* _tmp0_ = NULL;
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp0_ = uri;
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		diorite_system_open_uri (_tmp0_, &_inner_error_);
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			if (_inner_error_->domain == G_SPAWN_ERROR) {
#line 144 "system.c"
				goto __catch20_g_spawn_error;
			}
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			g_clear_error (&_inner_error_);
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			return;
#line 153 "system.c"
		}
	}
	goto __finally20;
	__catch20_g_spawn_error:
	{
		GError* e = NULL;
		const gchar* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		e = _inner_error_;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_inner_error_ = NULL;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp1_ = uri;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp2_ = e;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp3_ = _tmp2_->message;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		diorite_logger_lib_warning ("Unable to open %s: %s", _tmp1_, _tmp3_, NULL);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_g_error_free0 (e);
#line 177 "system.c"
	}
	__finally20:
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_clear_error (&_inner_error_);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		return;
#line 188 "system.c"
	}
}


/**
 * Loads contents of a file in UTF-8 encoding
 * 
 * @param file file to read
 * @return contents of the file
 * @throws GLib.Error on failure
 */
gchar* diorite_system_read_file (GFile* file, GError** error) {
	gchar* result = NULL;
	gchar* data = NULL;
	guint8* binary_data = NULL;
	gint binary_data_length1 = 0;
	gint _binary_data_size_ = 0;
	GFile* _tmp0_ = NULL;
	guint8* _tmp1_ = NULL;
	gsize _tmp2_;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 64 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp0_ = file;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_file_load_contents (_tmp0_, NULL, &_tmp1_, &_tmp2_, NULL, &_inner_error_);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	binary_data = (g_free (binary_data), NULL);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	binary_data = _tmp1_;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	binary_data_length1 = _tmp2_;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_binary_data_size_ = binary_data_length1;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_propagate_error (error, _inner_error_);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		binary_data = (g_free (binary_data), NULL);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_g_free0 (data);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		return NULL;
#line 238 "system.c"
	}
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp3_ = binary_data;
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp3__length1 = binary_data_length1;
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp4_ = g_strdup ((const gchar*) _tmp3_);
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_g_free0 (data);
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	data = _tmp4_;
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	binary_data = (g_free (binary_data), NULL);
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	binary_data = NULL;
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	binary_data_length1 = 0;
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_binary_data_size_ = binary_data_length1;
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp5_ = data;
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	data = NULL;
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	result = _tmp5_;
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	binary_data = (g_free (binary_data), NULL);
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_g_free0 (data);
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	return result;
#line 270 "system.c"
}


/**
 * 
 * Replaces contents of a file with text in UTF-8 encoding
 * 
 * @param file file to overwrite
 * @param contents contents of the file
 * @throws GLib.Error on failure
 */
static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
#line 1259 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1260 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	res = (guint8*) self;
#line 1260 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	res_length1 = -1;
#line 1260 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1261 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1261 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1261 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1261 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1262 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp3_ = res;
#line 1262 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1262 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1262 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1262 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	if (result_length1) {
#line 1262 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 322 "system.c"
	}
#line 1262 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	result = _tmp4_;
#line 1262 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	return result;
#line 328 "system.c"
}


void diorite_system_overwrite_file (GFile* file, const gchar* contents, GError** error) {
	GFile* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	guint8* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	guint8* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	GError * _inner_error_ = NULL;
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_return_if_fail (file != NULL);
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_return_if_fail (contents != NULL);
#line 344 "system.c"
	{
		GFile* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp0_ = file;
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp1_ = g_file_get_parent (_tmp0_);
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp2_ = _tmp1_;
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error_);
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_g_object_unref0 (_tmp2_);
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 361 "system.c"
			goto __catch21_g_error;
		}
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* e = NULL;
#line 84 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		e = _inner_error_;
#line 84 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_inner_error_ = NULL;
#line 84 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_g_error_free0 (e);
#line 375 "system.c"
	}
	__finally21:
#line 84 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 84 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_propagate_error (error, _inner_error_);
#line 84 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		return;
#line 384 "system.c"
	}
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp3_ = file;
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp4_ = contents;
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp5_ = string_get_data (_tmp4_, &_tmp5__length1);
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp6_ = _tmp5_;
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp6__length1 = _tmp5__length1;
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_file_replace_contents (_tmp3_, _tmp6_, (gsize) _tmp6__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error_);
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_propagate_error (error, _inner_error_);
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		return;
#line 404 "system.c"
	}
}


/**
 * Removes files in a directory.
 * 
 * @param dir	directory
 * @param recursive	recursive removal
 * @throw Error on failure
 */
void diorite_system_purge_directory_content (GFile* dir, gboolean recursive, GError** error) {
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp0_ = NULL;
	GFileEnumerator* _tmp1_ = NULL;
	GFileInfo* file_info = NULL;
	GError * _inner_error_ = NULL;
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_return_if_fail (dir != NULL);
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp0_ = dir;
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_tmp1_ = g_file_enumerate_children (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	enumerator = _tmp1_;
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_propagate_error (error, _inner_error_);
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		return;
#line 436 "system.c"
	}
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	while (TRUE) {
#line 440 "system.c"
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_ = NULL;
		GFileInfo* _tmp4_ = NULL;
		GFileInfo* _tmp5_ = NULL;
		GFileInfo* _tmp6_ = NULL;
		GFile* f = NULL;
		GFile* _tmp7_ = NULL;
		GFileInfo* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		GFile* _tmp10_ = NULL;
		GFile* _tmp11_ = NULL;
		GFileType _tmp12_ = 0;
		GFile* _tmp15_ = NULL;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp3_ = enumerator;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error_);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp2_ = _tmp4_;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			g_propagate_error (error, _inner_error_);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			_g_object_unref0 (file_info);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			_g_object_unref0 (enumerator);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			return;
#line 470 "system.c"
		}
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp5_ = _tmp2_;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp2_ = NULL;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_g_object_unref0 (file_info);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		file_info = _tmp5_;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp6_ = file_info;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		if (!(_tmp6_ != NULL)) {
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			_g_object_unref0 (_tmp2_);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			break;
#line 488 "system.c"
		}
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp7_ = dir;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp8_ = file_info;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp9_ = g_file_info_get_name (_tmp8_);
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp10_ = g_file_get_child (_tmp7_, _tmp9_);
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		f = _tmp10_;
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp11_ = f;
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp12_ = g_file_query_file_type (_tmp11_, 0, NULL);
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		if (_tmp12_ == G_FILE_TYPE_DIRECTORY) {
#line 506 "system.c"
			gboolean _tmp13_ = FALSE;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			_tmp13_ = recursive;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			if (_tmp13_) {
#line 512 "system.c"
				GFile* _tmp14_ = NULL;
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
				_tmp14_ = f;
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
				diorite_system_purge_directory_content (_tmp14_, TRUE, &_inner_error_);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
					g_propagate_error (error, _inner_error_);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
					_g_object_unref0 (f);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
					_g_object_unref0 (_tmp2_);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
					_g_object_unref0 (file_info);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
					_g_object_unref0 (enumerator);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
					return;
#line 532 "system.c"
				}
			}
		}
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp15_ = f;
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_file_delete (_tmp15_, NULL, &_inner_error_);
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			g_propagate_error (error, _inner_error_);
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			_g_object_unref0 (f);
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			_g_object_unref0 (_tmp2_);
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			_g_object_unref0 (file_info);
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			_g_object_unref0 (enumerator);
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
			return;
#line 554 "system.c"
		}
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_g_object_unref0 (f);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_g_object_unref0 (_tmp2_);
#line 560 "system.c"
	}
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_g_object_unref0 (file_info);
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	_g_object_unref0 (enumerator);
#line 566 "system.c"
}


/**
 * Deletes directory and its content and ignores IO errors.
 * 
 * @param dir	directory to remove
 * @param recursive	recursive removal
 * @return		true on success, false on failure
 */
gboolean diorite_system_try_purge_dir (GFile* dir, gboolean recursive) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	g_return_val_if_fail (dir != NULL, FALSE);
#line 582 "system.c"
	{
		GFile* _tmp0_ = NULL;
		gboolean _tmp1_ = FALSE;
		GFile* _tmp2_ = NULL;
#line 128 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp0_ = dir;
#line 128 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp1_ = recursive;
#line 128 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		diorite_system_purge_directory_content (_tmp0_, _tmp1_, &_inner_error_);
#line 128 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 595 "system.c"
			goto __catch22_g_error;
		}
#line 129 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_tmp2_ = dir;
#line 129 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_file_delete (_tmp2_, NULL, &_inner_error_);
#line 129 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 604 "system.c"
			goto __catch22_g_error;
		}
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError* e = NULL;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		e = _inner_error_;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_inner_error_ = NULL;
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		result = FALSE;
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		_g_error_free0 (e);
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		return result;
#line 622 "system.c"
	}
	__finally22:
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		g_clear_error (&_inner_error_);
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
		return FALSE;
#line 633 "system.c"
	}
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	result = TRUE;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/system.vala"
	return result;
#line 639 "system.c"
}


/**
 * System prctl function
 */
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



