/* nuvola-framebridge.c generated by valac 0.26.1, the Vala compiler
 * generated from nuvola-framebridge.vala, do not modify */

/*
 * Copyright 2011-2013 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <JavaScriptCore/JavaScript.h>
#include <stdlib.h>
#include <string.h>
#include <webkit/webkit.h>
#include <gio/gio.h>


#define NUVOLA_TYPE_FRAME_BRIDGE (nuvola_frame_bridge_get_type ())
#define NUVOLA_FRAME_BRIDGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_FRAME_BRIDGE, NuvolaFrameBridge))
#define NUVOLA_FRAME_BRIDGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_FRAME_BRIDGE, NuvolaFrameBridgeClass))
#define NUVOLA_IS_FRAME_BRIDGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_FRAME_BRIDGE))
#define NUVOLA_IS_FRAME_BRIDGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_FRAME_BRIDGE))
#define NUVOLA_FRAME_BRIDGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_FRAME_BRIDGE, NuvolaFrameBridgeClass))

typedef struct _NuvolaFrameBridge NuvolaFrameBridge;
typedef struct _NuvolaFrameBridgeClass NuvolaFrameBridgeClass;
typedef struct _NuvolaFrameBridgePrivate NuvolaFrameBridgePrivate;

#define NUVOLA_TYPE_JS_API (nuvola_js_api_get_type ())
#define NUVOLA_JS_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_JS_API, NuvolaJSApi))
#define NUVOLA_JS_API_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_JS_API, NuvolaJSApiClass))
#define NUVOLA_IS_JS_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_JS_API))
#define NUVOLA_IS_JS_API_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_JS_API))
#define NUVOLA_JS_API_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_JS_API, NuvolaJSApiClass))

typedef struct _NuvolaJSApi NuvolaJSApi;
typedef struct _NuvolaJSApiClass NuvolaJSApiClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _0(var) ((var == NULL) ? NULL : (var = ( (var), NULL)))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))

struct _NuvolaFrameBridge {
	GObject parent_instance;
	NuvolaFrameBridgePrivate * priv;
};

struct _NuvolaFrameBridgeClass {
	GObjectClass parent_class;
};

struct _NuvolaFrameBridgePrivate {
	void* _object_this;
	void* _context;
	GStaticRecMutex __lock__context;
	gchar* _frame_id;
	NuvolaJSApi* _js_api;
	WebKitWebFrame* _frame;
};

typedef enum  {
	NUVOLA_JS_ERROR_NOT_FOUND,
	NUVOLA_JS_ERROR_WRONG_TYPE,
	NUVOLA_JS_ERROR_FUNC_FAILED,
	NUVOLA_JS_ERROR_READ_ERROR,
	NUVOLA_JS_ERROR_NO_CONTEXT,
	NUVOLA_JS_ERROR_EXCEPTION
} NuvolaJSError;
#define NUVOLA_JS_ERROR nuvola_js_error_quark ()

static gpointer nuvola_frame_bridge_parent_class = NULL;

GType nuvola_frame_bridge_get_type (void) G_GNUC_CONST;
GType nuvola_js_api_get_type (void) G_GNUC_CONST;
#define NUVOLA_FRAME_BRIDGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_FRAME_BRIDGE, NuvolaFrameBridgePrivate))
enum  {
	NUVOLA_FRAME_BRIDGE_DUMMY_PROPERTY,
	NUVOLA_FRAME_BRIDGE_FRAME_ID,
	NUVOLA_FRAME_BRIDGE_JS_API,
	NUVOLA_FRAME_BRIDGE_FRAME
};
NuvolaFrameBridge* nuvola_frame_bridge_new (const gchar* frame_id, WebKitWebFrame* frame, NuvolaJSApi* js_api);
NuvolaFrameBridge* nuvola_frame_bridge_construct (GType object_type, const gchar* frame_id, WebKitWebFrame* frame, NuvolaJSApi* js_api);
static void nuvola_frame_bridge_set_frame_id (NuvolaFrameBridge* self, const gchar* value);
static void nuvola_frame_bridge_set_frame (NuvolaFrameBridge* self, WebKitWebFrame* value);
static void nuvola_frame_bridge_set_js_api (NuvolaFrameBridge* self, NuvolaJSApi* value);
void nuvola_frame_bridge_set_object (NuvolaFrameBridge* self, void* ctx, void* object_this);
void* nuvola_frame_bridge_get_real_context (NuvolaFrameBridge* self);
static void nuvola_frame_bridge_on_load_status_changed (NuvolaFrameBridge* self, GObject* o, GParamSpec* p);
static void _nuvola_frame_bridge_on_load_status_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
void nuvola_frame_bridge_clear_object (NuvolaFrameBridge* self);
gboolean nuvola_frame_bridge_ref_object (NuvolaFrameBridge* self, void** ctx, void** object);
static void* nuvola_frame_bridge_get_context (NuvolaFrameBridge* self);
gboolean nuvola_frame_bridge_unref_object (NuvolaFrameBridge* self, void* ctx, void* object);
WebKitWebFrame* nuvola_frame_bridge_get_frame (NuvolaFrameBridge* self);
GQuark nuvola_js_error_quark (void);
void nuvola_frame_bridge_execute_script_from_file (NuvolaFrameBridge* self, GFile* file, GValue* result, GError** error);
gchar* diorite_system_read_file (GFile* file, GError** error);
void nuvola_frame_bridge_execute_script (NuvolaFrameBridge* self, const gchar* script, const gchar* path, gint line, GValue* result, GError** error);
gchar* nuvola_js_tools_exception_to_string (void* ctx, void* value);
const gchar* nuvola_frame_bridge_get_frame_id (NuvolaFrameBridge* self);
NuvolaJSApi* nuvola_frame_bridge_get_js_api (NuvolaFrameBridge* self);
static void nuvola_frame_bridge_finalize (GObject* obj);
static void _vala_nuvola_frame_bridge_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_frame_bridge_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Creates new FrameBridge.
 * 
 * @param frame_id       custom identifier of the frame
 * @param frame          frame to be used for bridge
 * @param js_api         JavaScript API to be used for bridge
 * @param object_this    object to be used in context of 'this'
 */
static void _nuvola_frame_bridge_on_load_status_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	nuvola_frame_bridge_on_load_status_changed ((NuvolaFrameBridge*) self, _sender, pspec);
#line 140 "nuvola-framebridge.c"
}


NuvolaFrameBridge* nuvola_frame_bridge_construct (GType object_type, const gchar* frame_id, WebKitWebFrame* frame, NuvolaJSApi* js_api) {
	NuvolaFrameBridge * self = NULL;
	const gchar* _tmp0_ = NULL;
	WebKitWebFrame* _tmp1_ = NULL;
	NuvolaJSApi* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	WebKitWebFrame* _tmp4_ = NULL;
#line 60 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (frame_id != NULL, NULL);
#line 60 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (frame != NULL, NULL);
#line 60 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (js_api != NULL, NULL);
#line 60 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	self = (NuvolaFrameBridge*) g_object_new (object_type, NULL);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = frame_id;
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	nuvola_frame_bridge_set_frame_id (self, _tmp0_);
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp1_ = frame;
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	nuvola_frame_bridge_set_frame (self, _tmp1_);
#line 64 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp2_ = js_api;
#line 64 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	nuvola_frame_bridge_set_js_api (self, _tmp2_);
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp3_ = nuvola_frame_bridge_get_real_context (self);
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	nuvola_frame_bridge_set_object (self, _tmp3_, NULL);
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp4_ = frame;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_signal_connect_object ((GObject*) _tmp4_, "notify::load-status", (GCallback) _nuvola_frame_bridge_on_load_status_changed_g_object_notify, self, 0);
#line 60 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	return self;
#line 181 "nuvola-framebridge.c"
}


NuvolaFrameBridge* nuvola_frame_bridge_new (const gchar* frame_id, WebKitWebFrame* frame, NuvolaJSApi* js_api) {
#line 60 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	return nuvola_frame_bridge_construct (NUVOLA_TYPE_FRAME_BRIDGE, frame_id, frame, js_api);
#line 188 "nuvola-framebridge.c"
}


void nuvola_frame_bridge_clear_object (NuvolaFrameBridge* self) {
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (self != NULL);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	nuvola_frame_bridge_set_object (self, NULL, NULL);
#line 197 "nuvola-framebridge.c"
}


gboolean nuvola_frame_bridge_ref_object (NuvolaFrameBridge* self, void** ctx, void** object) {
	void* _vala_ctx = NULL;
	void* _vala_object = NULL;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 208 "nuvola-framebridge.c"
	{
		void* _tmp0_ = NULL;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp0_ = self->priv->_context;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_static_rec_mutex_lock (&self->priv->__lock__context);
#line 215 "nuvola-framebridge.c"
		{
			void* _tmp1_ = NULL;
			void* _tmp3_ = NULL;
			void* _tmp4_ = NULL;
			void* _tmp6_ = NULL;
			void* _tmp7_ = NULL;
			void* _tmp8_ = NULL;
			void* _tmp9_ = NULL;
#line 89 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_vala_ctx = NULL;
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_vala_object = NULL;
#line 91 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp1_ = self->priv->_object_this;
#line 91 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (_tmp1_ == NULL) {
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				result = FALSE;
#line 234 "nuvola-framebridge.c"
				{
					void* _tmp2_ = NULL;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					_tmp2_ = self->priv->_context;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 241 "nuvola-framebridge.c"
				}
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				if (ctx) {
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					*ctx = _vala_ctx;
#line 247 "nuvola-framebridge.c"
				}
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				if (object) {
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					*object = _vala_object;
#line 253 "nuvola-framebridge.c"
				}
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				return result;
#line 257 "nuvola-framebridge.c"
			}
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp3_ = nuvola_frame_bridge_get_context (self);
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_vala_ctx = _tmp3_;
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp4_ = _vala_ctx;
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (_tmp4_ == NULL) {
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				result = FALSE;
#line 269 "nuvola-framebridge.c"
				{
					void* _tmp5_ = NULL;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					_tmp5_ = self->priv->_context;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 276 "nuvola-framebridge.c"
				}
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				if (ctx) {
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					*ctx = _vala_ctx;
#line 282 "nuvola-framebridge.c"
				}
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				if (object) {
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					*object = _vala_object;
#line 288 "nuvola-framebridge.c"
				}
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				return result;
#line 292 "nuvola-framebridge.c"
			}
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp6_ = _vala_ctx;
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			JSGlobalContextRetain (_tmp6_);
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp7_ = self->priv->_object_this;
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp8_ = _vala_ctx;
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			JSValueProtect (_tmp8_, _tmp7_);
#line 99 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp9_ = self->priv->_object_this;
#line 99 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_vala_object = _tmp9_;
#line 100 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			result = TRUE;
#line 310 "nuvola-framebridge.c"
			{
				void* _tmp10_ = NULL;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp10_ = self->priv->_context;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 317 "nuvola-framebridge.c"
			}
#line 100 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (ctx) {
#line 100 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				*ctx = _vala_ctx;
#line 323 "nuvola-framebridge.c"
			}
#line 100 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (object) {
#line 100 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				*object = _vala_object;
#line 329 "nuvola-framebridge.c"
			}
#line 100 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return result;
#line 333 "nuvola-framebridge.c"
		}
		__finally41:
		{
			void* _tmp11_ = NULL;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp11_ = self->priv->_context;
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 342 "nuvola-framebridge.c"
		}
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_clear_error (&_inner_error_);
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		return FALSE;
#line 350 "nuvola-framebridge.c"
	}
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	if (ctx) {
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		*ctx = _vala_ctx;
#line 356 "nuvola-framebridge.c"
	}
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	if (object) {
#line 85 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		*object = _vala_object;
#line 362 "nuvola-framebridge.c"
	}
}


gboolean nuvola_frame_bridge_unref_object (NuvolaFrameBridge* self, void* ctx, void* object) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 104 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 104 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 104 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 376 "nuvola-framebridge.c"
	{
		void* _tmp0_ = NULL;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp0_ = self->priv->_context;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_static_rec_mutex_lock (&self->priv->__lock__context);
#line 383 "nuvola-framebridge.c"
		{
			gboolean _tmp1_ = FALSE;
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
			void* _tmp4_ = NULL;
			void* _tmp5_ = NULL;
			void* _tmp11_ = NULL;
			void* _tmp12_ = NULL;
			void* _tmp13_ = NULL;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp4_ = ctx;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp5_ = nuvola_frame_bridge_get_context (self);
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (_tmp4_ != _tmp5_) {
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp3_ = TRUE;
#line 401 "nuvola-framebridge.c"
			} else {
				void* _tmp6_ = NULL;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp6_ = ctx;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp3_ = _tmp6_ == NULL;
#line 408 "nuvola-framebridge.c"
			}
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (_tmp3_) {
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp2_ = TRUE;
#line 414 "nuvola-framebridge.c"
			} else {
				void* _tmp7_ = NULL;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp7_ = self->priv->_object_this;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp2_ = _tmp7_ == NULL;
#line 421 "nuvola-framebridge.c"
			}
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (_tmp2_) {
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp1_ = TRUE;
#line 427 "nuvola-framebridge.c"
			} else {
				void* _tmp8_ = NULL;
				void* _tmp9_ = NULL;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp8_ = self->priv->_object_this;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp9_ = object;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp1_ = _tmp8_ != _tmp9_;
#line 437 "nuvola-framebridge.c"
			}
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (_tmp1_) {
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				result = FALSE;
#line 443 "nuvola-framebridge.c"
				{
					void* _tmp10_ = NULL;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					_tmp10_ = self->priv->_context;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 450 "nuvola-framebridge.c"
				}
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				return result;
#line 454 "nuvola-framebridge.c"
			}
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp11_ = object;
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp12_ = ctx;
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			JSValueUnprotect (_tmp12_, _tmp11_);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp13_ = ctx;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			JSGlobalContextRelease (_tmp13_);
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			result = TRUE;
#line 468 "nuvola-framebridge.c"
			{
				void* _tmp14_ = NULL;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp14_ = self->priv->_context;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 475 "nuvola-framebridge.c"
			}
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return result;
#line 479 "nuvola-framebridge.c"
		}
		__finally42:
		{
			void* _tmp15_ = NULL;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp15_ = self->priv->_context;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 488 "nuvola-framebridge.c"
		}
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_clear_error (&_inner_error_);
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		return FALSE;
#line 496 "nuvola-framebridge.c"
	}
}


void nuvola_frame_bridge_set_object (NuvolaFrameBridge* self, void* ctx, void* object_this) {
	GError * _inner_error_ = NULL;
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (self != NULL);
#line 505 "nuvola-framebridge.c"
	{
		void* _tmp0_ = NULL;
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp0_ = self->priv->_context;
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_static_rec_mutex_lock (&self->priv->__lock__context);
#line 512 "nuvola-framebridge.c"
		{
			void* _tmp1_ = NULL;
			void* _tmp6_ = NULL;
			void* _tmp11_ = NULL;
			void* _tmp12_ = NULL;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp1_ = ctx;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (_tmp1_ != NULL) {
#line 522 "nuvola-framebridge.c"
				void* _tmp2_ = NULL;
				void* _tmp3_ = NULL;
#line 124 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp2_ = ctx;
#line 124 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				JSGlobalContextRetain (_tmp2_);
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp3_ = object_this;
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				if (_tmp3_ != NULL) {
#line 533 "nuvola-framebridge.c"
					void* _tmp4_ = NULL;
					void* _tmp5_ = NULL;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					_tmp4_ = object_this;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					_tmp5_ = ctx;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					JSValueProtect (_tmp5_, _tmp4_);
#line 542 "nuvola-framebridge.c"
				}
			}
#line 129 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			nuvola_frame_bridge_get_context (self);
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp6_ = self->priv->_context;
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (_tmp6_ != NULL) {
#line 551 "nuvola-framebridge.c"
				void* _tmp7_ = NULL;
				void* _tmp10_ = NULL;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp7_ = self->priv->_object_this;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				if (_tmp7_ != NULL) {
#line 558 "nuvola-framebridge.c"
					void* _tmp8_ = NULL;
					void* _tmp9_ = NULL;
#line 135 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					_tmp8_ = self->priv->_object_this;
#line 135 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					_tmp9_ = self->priv->_context;
#line 135 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
					JSValueUnprotect (_tmp9_, _tmp8_);
#line 567 "nuvola-framebridge.c"
				}
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp10_ = self->priv->_context;
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				JSGlobalContextRelease (_tmp10_);
#line 573 "nuvola-framebridge.c"
			}
#line 139 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp11_ = ctx;
#line 139 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			self->priv->_context = _tmp11_;
#line 140 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp12_ = object_this;
#line 140 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			self->priv->_object_this = _tmp12_;
#line 583 "nuvola-framebridge.c"
		}
		__finally43:
		{
			void* _tmp13_ = NULL;
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp13_ = self->priv->_context;
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 592 "nuvola-framebridge.c"
		}
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_clear_error (&_inner_error_);
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return;
#line 602 "nuvola-framebridge.c"
		}
	}
}


static void* nuvola_frame_bridge_get_context (NuvolaFrameBridge* self) {
	void* result = NULL;
	void* _tmp0_ = NULL;
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = self->priv->_context;
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	result = _tmp0_;
#line 146 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	return result;
#line 619 "nuvola-framebridge.c"
}


/**
 * Returns real JavaScript context for the frame.
 * 
 * @return    JavaScript context
 */
void* nuvola_frame_bridge_get_real_context (NuvolaFrameBridge* self) {
	void* result = NULL;
	void* ctx = NULL;
	WebKitWebFrame* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
#line 154 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = self->priv->_frame;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp1_ = webkit_web_frame_get_global_context (_tmp0_);
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	ctx = _tmp1_;
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	result = ctx;
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	return result;
#line 645 "nuvola-framebridge.c"
}


/**
 * Executes script from file.
 * 
 * The script will be executed in a context returned by {@link get_context().
 * The "this" keyword will refer to {@link object_this} if provided.
 * 
 * @param file    script to execute
 * @return        return value of the script
 * @throw         JSError on failure
 */
void nuvola_frame_bridge_execute_script_from_file (NuvolaFrameBridge* self, GFile* file, GValue* result, GError** error) {
	gchar* code = NULL;
	GValue _tmp11_ = {0};
	GFile* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	GValue _tmp15_ = {0};
	GValue _tmp16_ = {0};
	GError * _inner_error_ = NULL;
#line 170 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (self != NULL);
#line 170 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (file != NULL);
#line 672 "nuvola-framebridge.c"
	{
		gchar* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp1_ = file;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp2_ = diorite_system_read_file (_tmp1_, &_inner_error_);
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp0_ = _tmp2_;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 686 "nuvola-framebridge.c"
			goto __catch44_g_error;
		}
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp3_ = _tmp0_;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp0_ = NULL;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_g_free0 (code);
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		code = _tmp3_;
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_g_free0 (_tmp0_);
#line 699 "nuvola-framebridge.c"
	}
	goto __finally44;
	__catch44_g_error:
	{
		GError* e = NULL;
		GFile* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		GError* _tmp10_ = NULL;
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		e = _inner_error_;
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_inner_error_ = NULL;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp4_ = file;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp6_ = _tmp5_;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp7_ = e;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp8_ = _tmp7_->message;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp9_ = g_error_new (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_READ_ERROR, "Unable to read script %s: %s", _tmp6_, _tmp8_);
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp10_ = _tmp9_;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_g_free0 (_tmp6_);
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_inner_error_ = _tmp10_;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_g_error_free0 (e);
#line 736 "nuvola-framebridge.c"
		goto __finally44;
	}
	__finally44:
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_propagate_error (error, _inner_error_);
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_g_free0 (code);
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return;
#line 750 "nuvola-framebridge.c"
		} else {
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_g_free0 (code);
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_clear_error (&_inner_error_);
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return;
#line 760 "nuvola-framebridge.c"
		}
	}
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp12_ = file;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp13_ = g_file_get_uri (_tmp12_);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp14_ = _tmp13_;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	nuvola_frame_bridge_execute_script (self, code, _tmp14_, 1, &_tmp15_, &_inner_error_);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp16_ = _tmp15_;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_g_free0 (_tmp14_);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp11_ = _tmp16_;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_propagate_error (error, _inner_error_);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_g_free0 (code);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return;
#line 787 "nuvola-framebridge.c"
		} else {
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_g_free0 (code);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_clear_error (&_inner_error_);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return;
#line 797 "nuvola-framebridge.c"
		}
	}
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	*result = _tmp11_;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_g_free0 (code);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	return;
#line 806 "nuvola-framebridge.c"
}


/**
 * Executes script.
 * 
 * The script will be executed in a context returned by {@link get_context()}.
 * The "this" keyword will refer to {@link object_this} if provided.
 * 
 * @param script    script to execute
 * @return          return value of the script
 * @throw           JSError on failure
 */
void nuvola_frame_bridge_execute_script (NuvolaFrameBridge* self, const gchar* script, const gchar* path, gint line, GValue* result, GError** error) {
	GError * _inner_error_ = NULL;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (self != NULL);
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (script != NULL);
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (path != NULL);
#line 828 "nuvola-framebridge.c"
	{
		void* _tmp0_ = NULL;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		_tmp0_ = self->priv->_context;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_static_rec_mutex_lock (&self->priv->__lock__context);
#line 835 "nuvola-framebridge.c"
		{
			void* ctx = NULL;
			void* _tmp1_ = NULL;
			void* exception = NULL;
			GValue value = {0};
			void* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			void* _tmp4_ = NULL;
			void* _tmp5_ = NULL;
			void* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
			void* _tmp8_ = NULL;
			void* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			void* _tmp11_ = NULL;
			void* _tmp12_ = NULL;
			GValue _tmp13_ = {0};
			GValue _tmp14_ = {0};
			void* _tmp15_ = NULL;
			GValue _tmp22_ = {0};
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp1_ = nuvola_frame_bridge_get_context (self);
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			ctx = _tmp1_;
#line 200 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			exception = NULL;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp2_ = ctx;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp3_ = script;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp4_ = JSStringCreateWithUTF8CString (_tmp3_);
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp5_ = _tmp4_;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp6_ = self->priv->_object_this;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp7_ = path;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp8_ = JSStringCreateWithUTF8CString (_tmp7_);
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp9_ = _tmp8_;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			line = 0;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp10_ = line;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp12_ = JSEvaluateScript (_tmp2_, _tmp5_, _tmp6_, _tmp9_, _tmp10_, &_tmp11_);
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_0 (exception);
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			exception = _tmp11_;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_value_init (&_tmp13_, G_TYPE_POINTER);
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_value_set_pointer (&_tmp13_, _tmp12_);
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp14_ = _tmp13_;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			G_IS_VALUE (&_tmp13_) ? (g_value_unset (&_tmp13_), NULL) : NULL;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_JSStringRelease0 (_tmp9_);
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_JSStringRelease0 (_tmp5_);
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			value = _tmp14_;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp15_ = exception;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			if (_tmp15_ != NULL) {
#line 906 "nuvola-framebridge.c"
				void* _tmp16_ = NULL;
				void* _tmp17_ = NULL;
				gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
				GError* _tmp20_ = NULL;
				GError* _tmp21_ = NULL;
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp16_ = ctx;
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp17_ = exception;
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp18_ = nuvola_js_tools_exception_to_string (_tmp16_, _tmp17_);
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp19_ = _tmp18_;
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp20_ = g_error_new_literal (NUVOLA_JS_ERROR, NUVOLA_JS_ERROR_EXCEPTION, _tmp19_);
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp21_ = _tmp20_;
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_g_free0 (_tmp19_);
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_inner_error_ = _tmp21_;
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_0 (exception);
#line 931 "nuvola-framebridge.c"
				goto __finally45;
			}
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp22_ = value;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			*result = _tmp22_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_0 (exception);
#line 940 "nuvola-framebridge.c"
			{
				void* _tmp23_ = NULL;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				_tmp23_ = self->priv->_context;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 947 "nuvola-framebridge.c"
			}
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return;
#line 951 "nuvola-framebridge.c"
		}
		__finally45:
		{
			void* _tmp24_ = NULL;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			_tmp24_ = self->priv->_context;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock__context);
#line 960 "nuvola-framebridge.c"
		}
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		if (_inner_error_->domain == NUVOLA_JS_ERROR) {
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_propagate_error (error, _inner_error_);
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return;
#line 968 "nuvola-framebridge.c"
		} else {
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			g_clear_error (&_inner_error_);
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
			return;
#line 976 "nuvola-framebridge.c"
		}
	}
}


static gpointer _g_object_ref0 (gpointer self) {
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	return self ? g_object_ref (self) : NULL;
#line 985 "nuvola-framebridge.c"
}


static void nuvola_frame_bridge_on_load_status_changed (NuvolaFrameBridge* self, GObject* o, GParamSpec* p) {
	WebKitWebFrame* frame = NULL;
	GObject* _tmp0_ = NULL;
	WebKitWebFrame* _tmp1_ = NULL;
	WebKitWebFrame* _tmp2_ = NULL;
	WebKitWebFrame* _tmp3_ = NULL;
	WebKitLoadStatus _tmp4_ = 0;
	WebKitLoadStatus _tmp5_ = 0;
#line 208 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (self != NULL);
#line 208 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (o != NULL);
#line 208 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (p != NULL);
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = o;
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, WEBKIT_TYPE_WEB_FRAME) ? ((WebKitWebFrame*) _tmp0_) : NULL);
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	frame = _tmp1_;
#line 211 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp2_ = frame;
#line 211 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (_tmp2_ != NULL);
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp3_ = frame;
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp4_ = webkit_web_frame_get_load_status (_tmp3_);
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp5_ = _tmp4_;
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	if (_tmp5_ == WEBKIT_LOAD_FINISHED) {
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_signal_emit_by_name (self, "load-finished");
#line 1023 "nuvola-framebridge.c"
	}
#line 208 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_g_object_unref0 (frame);
#line 1027 "nuvola-framebridge.c"
}


const gchar* nuvola_frame_bridge_get_frame_id (NuvolaFrameBridge* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = self->priv->_frame_id;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	result = _tmp0_;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	return result;
#line 1042 "nuvola-framebridge.c"
}


static void nuvola_frame_bridge_set_frame_id (NuvolaFrameBridge* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = value;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_g_free0 (self->priv->_frame_id);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	self->priv->_frame_id = _tmp1_;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_object_notify ((GObject *) self, "frame-id");
#line 1061 "nuvola-framebridge.c"
}


NuvolaJSApi* nuvola_frame_bridge_get_js_api (NuvolaFrameBridge* self) {
	NuvolaJSApi* result;
	NuvolaJSApi* _tmp0_ = NULL;
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = self->priv->_js_api;
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	result = _tmp0_;
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	return result;
#line 1076 "nuvola-framebridge.c"
}


static void nuvola_frame_bridge_set_js_api (NuvolaFrameBridge* self, NuvolaJSApi* value) {
	NuvolaJSApi* _tmp0_ = NULL;
	NuvolaJSApi* _tmp1_ = NULL;
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (self != NULL);
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = value;
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_g_object_unref0 (self->priv->_js_api);
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	self->priv->_js_api = _tmp1_;
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_object_notify ((GObject *) self, "js-api");
#line 1095 "nuvola-framebridge.c"
}


WebKitWebFrame* nuvola_frame_bridge_get_frame (NuvolaFrameBridge* self) {
	WebKitWebFrame* result;
	WebKitWebFrame* _tmp0_ = NULL;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = self->priv->_frame;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	result = _tmp0_;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	return result;
#line 1110 "nuvola-framebridge.c"
}


static void nuvola_frame_bridge_set_frame (NuvolaFrameBridge* self, WebKitWebFrame* value) {
	WebKitWebFrame* _tmp0_ = NULL;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_return_if_fail (self != NULL);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_tmp0_ = value;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	self->priv->_frame = _tmp0_;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_object_notify ((GObject *) self, "frame");
#line 1124 "nuvola-framebridge.c"
}


static void nuvola_frame_bridge_class_init (NuvolaFrameBridgeClass * klass) {
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	nuvola_frame_bridge_parent_class = g_type_class_peek_parent (klass);
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_type_class_add_private (klass, sizeof (NuvolaFrameBridgePrivate));
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_frame_bridge_get_property;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_frame_bridge_set_property;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	G_OBJECT_CLASS (klass)->finalize = nuvola_frame_bridge_finalize;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_FRAME_BRIDGE_FRAME_ID, g_param_spec_string ("frame-id", "Frame id", "Identifier of this frame.", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_FRAME_BRIDGE_JS_API, g_param_spec_object ("js-api", "JavaScript API", "JavaScript API associated with this bridge.", NUVOLA_TYPE_JS_API, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_FRAME_BRIDGE_FRAME, g_param_spec_object ("frame", "Web frame", "Web frame associated with this bridge.", WEBKIT_TYPE_WEB_FRAME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1145 "nuvola-framebridge.c"
	/**
	 * Emitted when page has been loaded.
	 */
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_signal_new ("load_finished", NUVOLA_TYPE_FRAME_BRIDGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1151 "nuvola-framebridge.c"
}


static void nuvola_frame_bridge_instance_init (NuvolaFrameBridge * self) {
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	self->priv = NUVOLA_FRAME_BRIDGE_GET_PRIVATE (self);
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	self->priv->_object_this = NULL;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_static_rec_mutex_init (&self->priv->__lock__context);
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	self->priv->_context = NULL;
#line 1164 "nuvola-framebridge.c"
}


static void nuvola_frame_bridge_finalize (GObject* obj) {
	NuvolaFrameBridge * self;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_FRAME_BRIDGE, NuvolaFrameBridge);
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	g_static_rec_mutex_free (&self->priv->__lock__context);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_g_free0 (self->priv->_frame_id);
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	_g_object_unref0 (self->priv->_js_api);
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	G_OBJECT_CLASS (nuvola_frame_bridge_parent_class)->finalize (obj);
#line 1180 "nuvola-framebridge.c"
}


/**
 * FrameBridge provides bridge between Vala code and JavaScript environment for a given frame.
 * 
 * It provides methods to execute scripts in that frame with {@link object_this} used in context
 * of 'this'.
 */
GType nuvola_frame_bridge_get_type (void) {
	static volatile gsize nuvola_frame_bridge_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_frame_bridge_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaFrameBridgeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_frame_bridge_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaFrameBridge), 0, (GInstanceInitFunc) nuvola_frame_bridge_instance_init, NULL };
		GType nuvola_frame_bridge_type_id;
		nuvola_frame_bridge_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaFrameBridge", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_frame_bridge_type_id__volatile, nuvola_frame_bridge_type_id);
	}
	return nuvola_frame_bridge_type_id__volatile;
}


static void _vala_nuvola_frame_bridge_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaFrameBridge * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_FRAME_BRIDGE, NuvolaFrameBridge);
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		case NUVOLA_FRAME_BRIDGE_FRAME_ID:
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_value_set_string (value, nuvola_frame_bridge_get_frame_id (self));
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		break;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		case NUVOLA_FRAME_BRIDGE_JS_API:
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_value_set_object (value, nuvola_frame_bridge_get_js_api (self));
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		break;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		case NUVOLA_FRAME_BRIDGE_FRAME:
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		g_value_set_object (value, nuvola_frame_bridge_get_frame (self));
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		break;
#line 1225 "nuvola-framebridge.c"
		default:
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		break;
#line 1231 "nuvola-framebridge.c"
	}
}


static void _vala_nuvola_frame_bridge_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaFrameBridge * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_FRAME_BRIDGE, NuvolaFrameBridge);
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
	switch (property_id) {
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		case NUVOLA_FRAME_BRIDGE_FRAME_ID:
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		nuvola_frame_bridge_set_frame_id (self, g_value_get_string (value));
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		break;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		case NUVOLA_FRAME_BRIDGE_JS_API:
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		nuvola_frame_bridge_set_js_api (self, g_value_get_object (value));
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		break;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		case NUVOLA_FRAME_BRIDGE_FRAME:
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		nuvola_frame_bridge_set_frame (self, g_value_get_object (value));
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		break;
#line 1259 "nuvola-framebridge.c"
		default:
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-framebridge.vala"
		break;
#line 1265 "nuvola-framebridge.c"
	}
}



