/* inspectorwindow.c generated by valac 0.26.1, the Vala compiler
 * generated from inspectorwindow.vala, do not modify */

/*
 * Copyright 2011-2012 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <webkit/webkit.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>


#define NUVOLA_TYPE_INSPECTOR_WINDOW (nuvola_inspector_window_get_type ())
#define NUVOLA_INSPECTOR_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_INSPECTOR_WINDOW, NuvolaInspectorWindow))
#define NUVOLA_INSPECTOR_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_INSPECTOR_WINDOW, NuvolaInspectorWindowClass))
#define NUVOLA_IS_INSPECTOR_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_INSPECTOR_WINDOW))
#define NUVOLA_IS_INSPECTOR_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_INSPECTOR_WINDOW))
#define NUVOLA_INSPECTOR_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_INSPECTOR_WINDOW, NuvolaInspectorWindowClass))

typedef struct _NuvolaInspectorWindow NuvolaInspectorWindow;
typedef struct _NuvolaInspectorWindowClass NuvolaInspectorWindowClass;
typedef struct _NuvolaInspectorWindowPrivate NuvolaInspectorWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NuvolaInspectorWindow {
	GtkWindow parent_instance;
	NuvolaInspectorWindowPrivate * priv;
};

struct _NuvolaInspectorWindowClass {
	GtkWindowClass parent_class;
};

struct _NuvolaInspectorWindowPrivate {
	WebKitWebInspector* inspector;
	WebKitWebView* inspector_view;
};


static gpointer nuvola_inspector_window_parent_class = NULL;

GType nuvola_inspector_window_get_type (void) G_GNUC_CONST;
#define NUVOLA_INSPECTOR_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_INSPECTOR_WINDOW, NuvolaInspectorWindowPrivate))
enum  {
	NUVOLA_INSPECTOR_WINDOW_DUMMY_PROPERTY
};
NuvolaInspectorWindow* nuvola_inspector_window_new (WebKitWebView* view);
NuvolaInspectorWindow* nuvola_inspector_window_construct (GType object_type, WebKitWebView* view);
static WebKitWebView* nuvola_inspector_window_on_inspect_web_view (NuvolaInspectorWindow* self, WebKitWebView* view);
static WebKitWebView* _nuvola_inspector_window_on_inspect_web_view_webkit_web_inspector_inspect_web_view (WebKitWebInspector* _sender, WebKitWebView* p0, gpointer self);
static gboolean nuvola_inspector_window_on_inspector_show (NuvolaInspectorWindow* self);
static gboolean _nuvola_inspector_window_on_inspector_show_webkit_web_inspector_show_window (WebKitWebInspector* _sender, gpointer self);
static gboolean nuvola_inspector_window_real_delete_event (GtkWidget* base, GdkEventAny* event);
static void nuvola_inspector_window_finalize (GObject* obj);


/**
 * Creates new Inspector Window.
 * 
 * Memory management: The window is not destroyed on delete-event. If you want to destroy it
 * before end of application life cycle, you have to do it yourselves.
 * 
 * @param view	WebKit view to inspect
 */
static gpointer _g_object_ref0 (gpointer self) {
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 92 "inspectorwindow.c"
}


static WebKitWebView* _nuvola_inspector_window_on_inspect_web_view_webkit_web_inspector_inspect_web_view (WebKitWebInspector* _sender, WebKitWebView* p0, gpointer self) {
	WebKitWebView* result;
	result = nuvola_inspector_window_on_inspect_web_view ((NuvolaInspectorWindow*) self, p0);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	return result;
#line 101 "inspectorwindow.c"
}


static gboolean _nuvola_inspector_window_on_inspector_show_webkit_web_inspector_show_window (WebKitWebInspector* _sender, gpointer self) {
	gboolean result;
	result = nuvola_inspector_window_on_inspector_show ((NuvolaInspectorWindow*) self);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	return result;
#line 110 "inspectorwindow.c"
}


NuvolaInspectorWindow* nuvola_inspector_window_construct (GType object_type, WebKitWebView* view) {
	NuvolaInspectorWindow * self = NULL;
	WebKitWebView* _tmp0_ = NULL;
	WebKitWebInspector* _tmp1_ = NULL;
	WebKitWebInspector* _tmp2_ = NULL;
	WebKitWebInspector* _tmp3_ = NULL;
	WebKitWebInspector* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	self = (NuvolaInspectorWindow*) g_object_new (object_type, NULL);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp0_ = view;
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp1_ = webkit_web_view_get_inspector (_tmp0_);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_g_object_unref0 (self->priv->inspector);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	self->priv->inspector = _tmp2_;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp3_ = self->priv->inspector;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_signal_connect_object (_tmp3_, "inspect-web-view", (GCallback) _nuvola_inspector_window_on_inspect_web_view_webkit_web_inspector_inspect_web_view, self, 0);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp4_ = self->priv->inspector;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_signal_connect_object (_tmp4_, "show-window", (GCallback) _nuvola_inspector_window_on_inspector_show_webkit_web_inspector_show_window, self, 0);
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	gtk_window_set_default_size ((GtkWindow*) self, 600, 400);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp5_ = _ ("WebKit Inspector Window - Nuvola Player");
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp5_);
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	return self;
#line 152 "inspectorwindow.c"
}


NuvolaInspectorWindow* nuvola_inspector_window_new (WebKitWebView* view) {
#line 42 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	return nuvola_inspector_window_construct (NUVOLA_TYPE_INSPECTOR_WINDOW, view);
#line 159 "inspectorwindow.c"
}


static WebKitWebView* nuvola_inspector_window_on_inspect_web_view (NuvolaInspectorWindow* self, WebKitWebView* view) {
	WebKitWebView* result = NULL;
	WebKitWebView* _tmp0_ = NULL;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp1_ = NULL;
	WebKitWebView* _tmp2_ = NULL;
	WebKitWebView* _tmp3_ = NULL;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp0_ = (WebKitWebView*) webkit_web_view_new ();
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_object_ref_sink (_tmp0_);
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_g_object_unref0 (self->priv->inspector_view);
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	self->priv->inspector_view = _tmp0_;
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp1_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_object_ref_sink (_tmp1_);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	scroll = _tmp1_;
#line 54 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp2_ = self->priv->inspector_view;
#line 54 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	gtk_container_add ((GtkContainer*) scroll, (GtkWidget*) _tmp2_);
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) scroll);
#line 56 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	gtk_widget_show_all ((GtkWidget*) scroll);
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_tmp3_ = self->priv->inspector_view;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	result = _tmp3_;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_g_object_unref0 (scroll);
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	return result;
#line 204 "inspectorwindow.c"
}


static gboolean nuvola_inspector_window_on_inspector_show (NuvolaInspectorWindow* self) {
	gboolean result = FALSE;
#line 60 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	gtk_window_present ((GtkWindow*) self);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	result = FALSE;
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	return result;
#line 218 "inspectorwindow.c"
}


static gboolean nuvola_inspector_window_real_delete_event (GtkWidget* base, GdkEventAny* event) {
	NuvolaInspectorWindow * self;
	gboolean result = FALSE;
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	self = (NuvolaInspectorWindow*) base;
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	result = TRUE;
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	return result;
#line 235 "inspectorwindow.c"
}


static void nuvola_inspector_window_class_init (NuvolaInspectorWindowClass * klass) {
#line 30 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	nuvola_inspector_window_parent_class = g_type_class_peek_parent (klass);
#line 30 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	g_type_class_add_private (klass, sizeof (NuvolaInspectorWindowPrivate));
#line 30 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	((GtkWidgetClass *) klass)->delete_event = nuvola_inspector_window_real_delete_event;
#line 30 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	G_OBJECT_CLASS (klass)->finalize = nuvola_inspector_window_finalize;
#line 248 "inspectorwindow.c"
}


static void nuvola_inspector_window_instance_init (NuvolaInspectorWindow * self) {
#line 30 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	self->priv = NUVOLA_INSPECTOR_WINDOW_GET_PRIVATE (self);
#line 255 "inspectorwindow.c"
}


static void nuvola_inspector_window_finalize (GObject* obj) {
	NuvolaInspectorWindow * self;
#line 30 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_INSPECTOR_WINDOW, NuvolaInspectorWindow);
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_g_object_unref0 (self->priv->inspector);
#line 32 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	_g_object_unref0 (self->priv->inspector_view);
#line 30 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/gui/inspectorwindow.vala"
	G_OBJECT_CLASS (nuvola_inspector_window_parent_class)->finalize (obj);
#line 269 "inspectorwindow.c"
}


/**
 * Window with embedded WebKit Inspector used to examine pages loaded in WebViews.
 */
GType nuvola_inspector_window_get_type (void) {
	static volatile gsize nuvola_inspector_window_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_inspector_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaInspectorWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_inspector_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaInspectorWindow), 0, (GInstanceInitFunc) nuvola_inspector_window_instance_init, NULL };
		GType nuvola_inspector_window_type_id;
		nuvola_inspector_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "NuvolaInspectorWindow", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_inspector_window_type_id__volatile, nuvola_inspector_window_type_id);
	}
	return nuvola_inspector_window_type_id__volatile;
}



